package LaTeX;
#|#######################################################
#|##############################
sub scomment {
    return("%% ftagshtml START=\"$_[0]\" %%\n") ;
}
#|##############################
sub ecomment {
    return("%% ftagshtml END=\"$_[0]\" %%\n") ;
}
#|##############################
sub bol {
    return("\\begin{enumerate}") ;
}
#|##############################
sub eol {
    return("\\end{enumerate}") ;
}
#|##############################
sub bul {
    return("\\begin{itemize}") ;
}
#|##############################
sub eul {
    return("\\end{itemize}") ;
}
#|##############################
sub br {
    return("\\hfill\\\\\\noindent") ;
}
#|##############################
sub chapter {
    return("\\chapter{$_[0]}") ;
}
#|##############################
sub sepline {
    return("%%%%%%%%%%%%%%%%%%%%%%%%%") ;
}
#|##############################
sub li {
    return("\\item ") ;
}
#|##############################
sub DeclareAnalysis {
    local($source,$index,$ligne,$Routine,$LocalName)=@_;
    local($localRoutine,$localFile,$localNum)=&main::GetInfoRoutine($Routine) ;
    local($tag) = "R_$localRoutine" ;
    if (($main::father{$Routine}) && (&main::IsFatherNotTop("$main::father{$Routine}") > 0)) {
	$tag = "R_$localRoutine$localNum" ;
    }
    local($latexFile) = &LaTeXProtect($localFile);
    local($latexRoutine) = &LaTeXProtect($localRoutine);
    return($tag,$latexRoutine,$latexFile,$localNum) ;
}
#|##############################
sub InputAnalysis {
    local($source,$index,$ligne,$Routine,$LocalName)=@_;
    local($localRoutine,$localFile,$localNum)=&main::GetInfoRoutine($Routine) ;
    local($fic) = &fichiers::InputFileOfWrite($localFile) ;
    &fichiers::GetInputCibleOfWrite($localRoutine) ;
    local($tag) = "R_$localRoutine" ;
    local($latexFile) = &LaTeXProtect($fic);
    local($latexRoutine) = &LaTeXProtect($localRoutine);
    return($tag,$latexRoutine,$latexFile,$localNum) ;
}
#|##############################
sub IncludeAnalysis {
    local($source,$index,$ligne,$Routine,$LocalName)=@_;
    local($localRoutine,$localFile,$localNum)=&main::GetInfoRoutineCasei($Routine) ;
    local($fic) = &fichiers::IncludeFileOfWrite($localFile) ;
    &fichiers::GetIncludeCibleOfWrite($localRoutine) ;
    local($tag) = "R_$localRoutine" ;
    local($latexFile) = &LaTeXProtect($fic);
    local($latexRoutine) = &LaTeXProtect($localRoutine);
    return($tag,$latexRoutine,$latexFile,$localNum) ;
}
#|##############################
sub DeclareNolabel {
    local($source,$index,$ligne,$Routine,$LocalName)=@_;
    local($tag,$latexRoutine,$latexFile,$localNum) = (&DeclareAnalysis(@_)) ;
    return(&Ref) ;
#    return(&Declare(@_,0)) ;
}
#|##############################
sub IncludeNolabel {
    local($source,$index,$ligne,$Routine,$LocalName)=@_;
    local($tag,$latexRoutine,$latexFile,$localNum) = (&IncludeAnalysis(@_)) ;
    return(&Nolabel) ;
}
#|##############################
sub InputNolabel {
    local($source,$index,$ligne,$Routine,$LocalName)=@_;
    local($tag,$latexRoutine,$latexFile,$localNum) = (&InputAnalysis(@_)) ;
    return(&Ref) ;
}
#|##############################
sub InputLabel {
    local($source,$index,$ligne,$Routine,$LocalName)=@_;
    local($tag,$latexRoutine,$latexFile,$localNum) = (&InputAnalysis(@_)) ;
    return(&Ref) ;
}
#|##############################
sub DeclareRef {
    local($source,$index,$ligne,$Routine,$LocalName,$putFile)=@_;
    local($tag,$latexRoutine,$latexFile,$localNum) = (&DeclareAnalysis(@_)) ;
    if ($latexFile =~ /^\//) {
	$latexFile = &fichiers::IncludeFileOfWrite($latexFile) ;
    }
    if ($putFile =~ /^\//) {
	$putFile = &fichiers::IncludeFileOfWrite($putFile) ;
    }
    return(&Ref) ;
}
#|##############################
sub IncludeRef {
    local($source,$index,$ligne,$Routine,$LocalName,$putFile)=@_;
    local($tag,$latexRoutine,$latexFile,$localNum) = (&IncludeAnalysis(@_)) ;
    return(&Ref) ;
}
#|##############################
sub DeclareLabel {
    local($source,$index,$ligne,$Routine,$LocalName)=@_;
    local($tag,$latexRoutine,$latexFile,$localNum) = (&DeclareAnalysis(@_)) ;
    return(&Label) ;
}
#|##############################
sub IncludeLabel {
    local($source,$index,$ligne,$Routine,$LocalName)=@_;
    local($localRoutine,$localFile,$localNum)=&main::GetInfoRoutineCasei($Routine) ;
    local($fic) = &fichiers::IncludeFileOfWrite($localFile) ;
    &fichiers::GetIncludeCibleOfWrite($localRoutine) ;
    local($tag) = "R_$localRoutine" ;
    local($latexFile) = &LaTeXProtect($fic);
    local($latexRoutine) = &LaTeXProtect($localRoutine);
    return(&Label) ;
}
#|##############################
sub Label {
    my($lien,$cref) = ("","") ;
    $lien = "{\\bf $latexRoutine}";
    $cref = $tag;
    if ($localNum) {
	$lien .= "\\label{$cref} is declared in {\\bf $latexFile}, ($localNum).";
    } else {
	$lien .= "\\label{$cref} is labelled in {\\bf $latexFile}.";
# Check This
    }
    $ligne =~ s/$LocalName/$lien/;
    return("$ligne") ;
}
#|##############################
sub Ref {
    my($lien) = ("","") ;
    if ($putFile) {
	$lien = "{\\bf $latexRoutine}(\\ref{$tag})";
    } else {
	$lien = "{\\bf $latexRoutine}";
    }
    $ligne =~ s/$LocalName/$lien/;
    return("$ligne") ;
}
#|##############################
sub Nolabel {
    my($lien) = ("","") ;
    if ($latexFile) {
	$lien = "{\\bf $latexRoutine}(\\ref{$tag})";
    } else {
	$lien = "{\\it $latexRoutine}";
    }
    $ligne =~ s/$LocalName/$lien/;
    return("$ligne") ;
}
#|##############################
sub iliste {
    return(&liste(@_));
}
#|##############################
sub liste {
    local($source,$index,$Routine,@numlist)=@_;
    local($latexligne)="";
    $numloc=1 ;
    foreach $num (@numlist) {
	if ($numloc) {
	    $numloc=0 ;
	} else {
	    $latexligne .= ", ";
	}
	$latexligne .= " ($num)";
    }
    $latexligne .= " \n";
    return($latexligne);
}
#|##############################
sub Private_Called {
    local($htmlligne) = &main::Index_Private_Called(@_) ;
    return($htmlligne);
}
#|##############################
sub Private_Calls {
    local($htmlligne) = &main::Index_Private_Calls(@_) ;
    return($htmlligne);
}
#|##############################
sub Private_Defines {
    local($htmlligne) = &main::Index_Private_Defines(@_) ;
    return($htmlligne);
}
#|##############################
sub Private_Used {
    local($htmlligne) = &main::Index_Private_Used(@_) ;
    return($htmlligne);
}
#|##############################
sub Private_Uses {
    local($htmlligne) = &main::Index_Private_Uses(@_) ;
    return($htmlligne);
}
#%###################################################
sub LaTeXProtect {
    local($Nom)=@_;
    $Nom =~ s/_/\\_/g ;
    return($Nom) ;
}
#|##############################
sub Private_Includes {
    local($htmlligne) = &main::Index_Private_Includes(@_) ;
    return($htmlligne);
}
#|##############################
sub Private_Included {
    local($htmlligne) = &main::Index_Private_Included(@_) ;
    return($htmlligne);
}
#|##############################
sub Private_Inputs {
    local($htmlligne) = &main::Index_Private_Inputs(@_) ;
    return($htmlligne);
}
#|##############################
sub Private_Inputed {
    local($htmlligne) = &main::Index_Private_Inputed(@_) ;
    return($htmlligne);
}
#|#######################################################
1;
