package fichiers;
#|########################################################################
# ftagshtml: transforms fortran and C source into HTML or PostScript or PDF.
#    Copyright (C) 2000 Olivier Cessenat.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#|########################################################################
#|#######################################################
sub basename {
    local($NomCompletDuRepertoire)=@_ ;
    local(@NomListe) = (split("/", $NomCompletDuRepertoire)) ;
    return($NomListe[$#NomListe]);
}
#|#######################################################
sub dirname {
    my(@NomListe) = (split("/", $_[0])) ;
    pop(@NomListe) ;
    return(join '/', @NomListe);
}
#|#######################################################
sub CheminAbsoluDeAaB {
    local($a,$b)=@_;
    if ($b =~ /^\//) {
	return($b) ;
    }
    if ($b =~ /^\.\/(.*)/) {
	$b = $1 ;
    }
    while ($b =~ /^\.\.\/(.*)/) {
	$b = $1 ;
	if ($a =~ /^(.*)\/.*$/) {
	    $a =$1;
	} else {
	    last ;
	}
    }
    if ($b =~ /(.*)\/$/) {
	$b = $1 ;
    }
    return("$a/$b");
}
#|#######################################################
sub CheminRelatifDeAaB {
    local($a,$b)=@_;
    local($t)="";
    local(@a)=split(/\//,$a);
    local(@b)=split(/\//,$b);
    while ((@a) && (@b) && ("$a[0]" eq "$b[0]")) {
	shift(@a) ;
	shift(@b) ;
    }
    for($i=0;$i <= $#a;$i++) {  
	$t .= "../" ;
    }
    for($i=0;$i <= $#b;$i++) {  
	$t .= "$b[$i]/" ;
    }
    if ($t =~ /\/$/) {
	chop($t);
    }
    return($t) ;
}
#|#######################################################
sub MonDiff {
    local($DIRC,$DIRE,$file)=@_;
    local($diff)="";
    $diff = &CheminRelatifDeAaB($DIRE,$DIRC)."/$file" ;
    $diff =~ s/\/\.\//\//g ;
    return($diff);
}
#|#######################################################
sub GetFileCurrent {
    local($file)=@_;
    local($diff)="";
    $diff = &CheminRelatifDeAaB("$main::DIRE",$main::DIRC) ;
    $file =~ s/^$diff//  ;
    if ($file =~ /^\/(.*)/) {
	$file = $1 ;
    }
    return($file);
}
#|#######################################################
sub GetLocFile {
    local($file_loc)=@_;
    unless ( $file_loc =~ /^\//) {
	$file_loc = &MonDiff("$main::DIRC","$main::DIRE","$file_loc") ;
    }
    if ( $file_loc =~ /\/\/(.+)/) {
	$file_loc = '/'."$1" ;
    }
    return($file_loc);
}

#|#######################################################
sub GetIncludeSource {
# Gives a relative path from $main::DIRE to source directory of file
    my($fic) = &CheminRelatifDeAaB("$main::DIRE",&dirname($_[0])) ;
    if ($fic) {
	$fic .= '/'.&basename($_[0]) ;
    } else {
	$fic = &basename($_[0]) ;
    }
#    &GetIncludeCibleOfWrite($fic) ;
    return($fic) ;
}
#|#######################################################
sub GetInputCibleOfWrite { # donne le nom cible du fichier include
    if ( $_[0] =~ /^\.\.\/(.*)/ ) {
	$_[0] = $1 ;
    }
    if ( $_[0] =~ /^\.\/(.*)/ ) {
	$_[0] = $1 ;
    }
    $_[0] =~ s/\//_/g;
   if ($_[0] =~ /^_(.*)/) { $_[0] = $1 ; } ;
}
#|#######################################################
sub GetIncludeCibleOfWrite { # donne le nom cible du fichier include
   if ( $_[0] =~ /^\.\.\/(.*)/ ) {
      $_[0] = $1 ;
   }
   if ( $_[0] =~ /^\.\/(.*)/ ) {
      $_[0] = $1 ;
   }
   $_[0] =~ s/\//_/g;
   if ($_[0] =~ /^_(.*)/) { $_[0] = $1 ; } ;
}
#|#######################################################
sub IncludeFileOfWrite { # donne le nom cible du fichier include
    my($fic) = &CheminRelatifDeAaB("$main::DIRC",&dirname($_[0])) ;
    if ($fic) {
	$fic .= '/'.&basename($_[0]) ;
    } else {
	$fic = &basename($_[0]) ;
    }
    &GetIncludeCibleOfWrite($fic) ;
    while ($fic =~ /^\.\._(.*)/) { $fic = $1 ; } ;
    return($fic) ;
}
#|#######################################################
sub InputFileOfWrite { # donne le nom cible du fichier include
    my($fic) = &CheminRelatifDeAaB("$main::DIRC",&dirname($_[0])) ;
    if ($fic) {
	$fic .= '/'.&basename($_[0]) ;
    } else {
	$fic = &basename($_[0]) ;
    }
    &GetInputCibleOfWrite($fic) ;
    while ($fic =~ /^\.\._(.*)/) { $fic = $1 ; } ;
    return($fic) ;
}
#|#######################################################
sub find_include {
# Ouvre le fichier si le trouve et dfinit le
# filehandle INCLUDE.
# Retourne le nom du fichier ouvert ou null.
    local($fic)=@_;
    if (open(INCLUDE,"<$fic")) {
	close(INCLUDE);
	return "$fic" ;
    } elsif (open(INCLUDE,"<s.$fic")) {
	close(INCLUDE);
	return "s.$fic" ;
    } else {
	foreach $DIRECTOIRE (@main::TAGSHTML_PATH) {
	    if (open(INCLUDE,"$DIRECTOIRE/$fic")) {
		$fic = "$DIRECTOIRE/$fic" ;
		close(INCLUDE);
		return "$fic" ;
	    }
	}
    }
    return(0) ;
}

#|#######################################################
sub find_input {
# Ouvre le fichier si le trouve et dfinit le
# filehandle INPUT.
# Retourne le nom du fichier ouvert ou null.
    local($fic)=@_;
    if (open(INPUT,"<$fic")) {
	close(INPUT);
	return "$fic" ;
    } elsif (open(INPUT,"<s.$fic")) {
	close(INPUT);
	return "s.$fic" ;
    } else {
	foreach $DIRECTOIRE (@main::TAGSHTML_PATH) {
	    if (open(INPUT,"$DIRECTOIRE/$fic")) {
		$fic = "$DIRECTOIRE/$fic" ;
		close(INPUT);
		return "$fic" ;
	    }
	}
    }
    return(0);
}
#|########################################################################
sub UnixCopy {
    my($source,$target) = @_ ;
    if ($main::linux) {
	system "cp $source $target";
    } else {
	if ((open(SOURCE,"<$source")) && (open(TARGET,">$target"))) {
	    while (<SOURCE>) {
		print TARGET $_ ;
	    }
	    close(SOURCE) ;
	    close(TARGET) ;
	} else {
	    warn "cp $source to $target failed" ;
	}
    }
}
#|#######################################################
sub RecursiveMkdir {
    my($DIRE) = @_ ;
    if ($main::linux) {
	system "mkdir -p $DIRE";
    } else {
	my(@d) = () ;
	while ($rep = &basename($DIRE)) {
	    $DIRE = &dirname($DIRE) ;
	    push(@d,$rep) ;
	}
	my($c) = "";
	while ($rep = pop(@d)) {
	    $c .= "/$rep";
	    unless ( -d "$c") {
		mkdir $c ;
	    }
	}
    }
}
#|########################################################################
1;
