package index;
#|########################################################################
# ftagshtml: transforms fortran and C source into HTML or PostScript or PDF.
#    Copyright (C) 2000 Olivier Cessenat.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#|########################################################################
sub En_Tete_Input {
    local($file,$fic,$source)=@_;
    local($ligne)="";
    $file_bis = $fic ;
    $main::Verbatim_Style = 0;
    $enteteloc=main::En_Tete_All($file_bis,"input",$source);
# en-tete du fichier
#-------------------
    $ligne="<HTML><HEAD>
<TITLE>$fic $main::RepCodeSource</TITLE>\n";
    unless ($main::opt_nostyle) {
	$ligne .= &fontify::stylesheet ;
    }
    $ligne .= "</HEAD>
<BODY BGCOLOR=WHITE LINK=BLUE ALINK=GREEN VLINK=#9910DD>
<H3 align=center>$fic</H3>".&main::last_modified($file)."
$enteteloc
";
    if (($source) && ("$source" eq "source")) {
	$ligne .= "<P> Liste des fichiers utilisant <A HREF=\"${fic}_i.html\" TARGET=\"index\">$file</A>.";
    } else {
	$ligne .= "<P> Liste des fichiers utilisant <A HREF=\"inpuindex_c.html#R_$fic\" TARGET=\"source\">$fic</A>.";
    }
    $ligne .= "<HR>\n";
    return($ligne);
} ;
#|#######################################################
sub HeveaConstructFile {
    local($hevea,$hevealigne)=@_;
    print STDOUT ".";
    unless ($main::reuse) {
	if (open (HEVEA, "${hevea}.tex")){
	    return ;
	}
    }
    if (open (HEVEA, ">${hevea}.tex")){
	print HEVEA "$hevealigne\n";
	close(HEVEA);
	system "cd $main::DIRE ; latex '\\nonstopmode\\input{${hevea}.tex}' >/dev/null >&1";
	system "hevea ${hevea}.tex -o ${hevea}.html 2>/dev/null >&1";
	print STDOUT ".";
    }
}
#|#######################################################
sub latex2html {
# We shall build a database of external references for LaTeX2HTML
    open(LATEX2HTML,">$main::DIRE/latex2html.pl") or die "DBM Error for l2h";
    local($reference,$file,$tag) = ("","","");
    print LATEX2HTML "# ftagshtml $main::version external references for\n";
    print LATEX2HTML "# LaTeX2HTML 98.1p1 release (March 2nd, 1998)\n";
    print LATEX2HTML "# Associate labels original text with physical files.\n\n";
    foreach $reference (keys %main::label) {
	($file,$tag) = split (/\#/,$main::label{$reference});
	$file .= "_c.html" ;
	print LATEX2HTML '$external_labels{"'.$tag.'"} = "$URL/'.$file."\";\n";
    }
    print LATEX2HTML "\n1;\n";
    close(LATEX2HTML);
}
#|#######################################################
sub FileName {
    local($nom)=@_;
    if ($nom =~ /([\w+_\.]+)$/) { $nom=$1; }
    return($nom);
}
#|#######################################################
sub Index_T_Latex {
# index des fonctions
    open(LATEX,">$main::DIRE/texindex.tex");
    &Ouvre_SLatex ;
    &Ouvre_LLatex ;
    $lang = "LaTeX";
    if (%main::programmes) {
	@liste=sort keys %main::programmes ;
	print LATEX main::Build_Index_Chapter("source","index","Programme",$lang,@liste);
    }
    if (%main::functions) {
	@liste=sort keys %main::functions ;
	print LATEX main::Build_Index_Chapter("source","index","Functions",$lang,@liste);
    }
    if (%main::routines) {
	@liste=sort keys %main::routines ;
	print LATEX main::Build_Index_Chapter("source","index","Routines",$lang,@liste);
    }
    if (%main::module) {
	@liste=sort keys %main::module ;
	print LATEX main::Build_Index_Chapter("source","index","Modules",$lang,@liste);
    }
    if (%main::interfaces) {
	@liste=sort keys %main::interfaces ;
	print LATEX main::Build_Index_Chapter("source","index","Interfaces",$lang,@liste);
    }
    if (%{main::f90included}) {
	@liste=sort keys %{main::f90included} ;
	print LATEX main::Build_Index_Chapter("source","index","Includes",$lang,@liste);
    }
}
#|#######################################################
sub Ouvre_SLatex {
    open(SLATEX,">$main::DIRE/Sindex.tex");
    $MonCode = &LaTeX::LaTeXProtect($main::RepCodeSource) ;
print SLATEX <<'INFORMATION';
\documentclass[a4paper,10pt,twoside]{report}
\usepackage{fancyhdr}
\usepackage{makeidx}
\usepackage{hyperref}
\pagestyle{fancy}
%%\usepackage{french}
\textheight 23.0cm
\textwidth 16.0cm
\topmargin -0.55cm
\headsep 0.7cm
\marginparwidth 0.cm
\marginparsep 0.cm
\oddsidemargin 0.4cm
\evensidemargin -0.925cm 
\pagestyle{fancy}
\addtolength{\headwidth}{0cm}
\lfoot{\today}
INFORMATION
print SLATEX "\\rfoot{$main::USER}\n" ;
print SLATEX "\\lhead{Presentation of code $MonCode.}\n" ;
print SLATEX <<'INFORMATION';
\begin{document}
INFORMATION
print SLATEX "\\author{$main::USER}\n" ;
print SLATEX "\\title{Presentation of code $MonCode.}\n" ;
print SLATEX <<'INFORMATION';
\maketitle
%%\setcounter{page}{2}
\tableofcontents
\input texindex.tex
\end{document}
INFORMATION
    close (SLATEX) ;
}

#|#######################################################
sub Ouvre_LLatex {
    open(LLATEX,">$main::DIRE/Lindex.tex");
    $MonCode = &LaTeX::LaTeXProtect($main::RepCodeSource) ;
print LLATEX <<'INFORMATION';
\documentclass[a4paper,12pt]{report}
\usepackage{fancyhdr}
\usepackage{makeidx}
\usepackage{hyperref}
\pagestyle{fancy}
\lfoot{\today}
INFORMATION
print LLATEX "\\rfoot{$main::USER}\n" ;
print LLATEX "\\lhead{Presentation of code $MonCode.}\n" ;
print LLATEX <<'INFORMATION';
\begin{document}
INFORMATION
print LLATEX "\\author{$main::USER}\n" ;
print LLATEX "\\title{Presentation of code $MonCode.}\n" ;
print LLATEX <<'INFORMATION';
\maketitle
\tableofcontents
\input texindex.tex
\end{document}
INFORMATION
    close (LLATEX) ;
} ;
#|#######################################################
sub LatexHeveaProcess {
    local($ligne)=@_;
    local($tete,$queue);
$tete = '\\documentclass[leqno]{report}
\\usepackage[latin1]{inputenc}
\\usepackage{a4,psfig,alltt}
\\usepackage{fancyhdr}
\\usepackage[dvips]{graphicx}
\\usepackage[dvips]{changebar}
\\usepackage{heqn}
\\usepackage{epsfig}
\\usepackage{makeidx}
\\usepackage{verbatim}
\\usepackage{amsmath}
\\usepackage{amsthm}
\\usepackage{amsfonts}
%%\\usepackage{french}
\\usepackage{html,htmllist}
\\usepackage{colordvi}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\\renewcommand{\\varepsilon}{\\epsilon}
\\renewcommand{\\vec}[1]{{\\stackrel{\\rightarrow}{\\displaystyle #1}}}
\\renewcommand{\\sqrt}[1]{\\left(#1\\right)^{1/2}}
\\renewcommand{\\binom}[2]{C_{#1}^{#2}}
\\renewcommand{\\text}[1]{{\\rm{#1}}}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\\newtheorem{theorem}{\\bf Thorme}
\\newtheorem{hypothesis}{Hypothse}
\\newtheorem{proposition}{Proposition}
\\newtheorem{lemma}{\\bf Lemme}
\\newtheorem{corollary}{\\bf Corollaire}
\\newtheorem{notation}{Notation}
\\newtheorem{definition}{Dfinition}
\\newtheorem{conjecture}{Conjecture}
\\newtheorem{remark}{Remarque}
\\newtheorem{modif}{Modification de source}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
';
    
    if ($ENV{def1}) {
	$tete .= '\\input '."$ENV{def1}\n" ;
    }
    if ($ENV{def2}) {
	$tete .= '\\input '."$ENV{def2}\n" ;
    }
    if ($ENV{INFO}) {
	$tete .= '\\input '."$ENV{INFO}\n" ;
    }
    if ($ENV{HEVEA_OVER}) {
	$tete .= '\\input '."$ENV{HEVEA_OVER}\n" ;
    }
	$tete .= '
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\\begin{document}
';
    $queue ='
\\end{document}
' ;
    $ligne="$tete"."$ligne"."$queue" ;

    return ($ligne);
}
#|#######################################################
sub Input_Construct {
    local($file,$cible,$totalRoutine)=@_;
# What a silly programmer !
    $main::file = $file ;
    local($ligne)="";
    if (open (INPUT, "<$file")){
	open (TARGET, ">$main::DIRE/${cible}_c.html") or die "Probleme 0" ;
	open (LEFTINDEX, ">$main::DIRE/${cible}_i.html") or die "Probleme 0" ;
	open (MAINFRAME, ">$main::DIRE/${cible}.html") or die "Probleme 0" ;
	print MAINFRAME '<html>
   <head>
   <title>'.$cible.'</title>'."\n";
    unless ($main::opt_nostyle) {	
	print MAINFRAME &fontify::stylesheet ;
    }	
    print MAINFRAME '</head>
<frameset COLS="25%,*" BORDER="1" MARGINHEIGHT="0" MARGINWIDTH="0">
  <frame SRC="'.${cible}.'_i.html" NAME="index">
  <frame SRC="'.${cible}.'_c.html" NAME="source">
</frameset>
</html>' ;
        close (MAINFRAME) ;
        local($header)="";
        $header = &En_Tete_Input($file,$cible,"source");
	print TARGET $header ;
	print TARGET "<A Name=R_$file></A>" ;
#        $header = &En_Tete_Input($file,$cible,"index");
#	    $header .= &Manage_Index_Input($file,$cible,"source");
        $header = &En_Tete_Input($file,$cible,"index");
	print LEFTINDEX $header ;
        $ligne = &{$main::affiche{"Private_Inputs"}}($totalRoutine,"source") ;
        $ligne .= &{$main::affiche{"Private_Inputed"}}($totalRoutine,"source") ;
        print LEFTINDEX "$ligne" ;
        close (LEFTINDEX) ;
        $ligne = "";
	local($normalligne)="";
	if ($main::opt_hevea) {
	    while (defined($LIGNEINP=<INPUT>)) {
		$ligne .= $LIGNEINP ;
		if ($LIGNEINP =~ /[<>]/) {
		    $LIGNEINP =~ s/</&lt;/g ;
		    $LIGNEINP =~ s/>/&gt;/g ;
		}
		$normalligne .= &main::LatexBuiltinProcess($LIGNEINP);
	    }
	    $hevea="$main::DIRE/hevea_$cible";
	    $hevea =~ s/\.\w+$//;
	    local($hevealigne) = &LatexHeveaProcess($ligne);
	    &HeveaConstructFile($hevea,$hevealigne);
	    local($target)="hevea_$cible";
	    $target =~ s/\.\w+$//;
	    if ($target =~ /.*\/([\w\._]+)/) {
		local($target)=$1 ;
	    }
	    print TARGET "<BR><A Href=$target.html>Hevea Translation</A>\n";
	    print TARGET "<BR><A Href=file:$ENV{FTAGSHTML_DIR}/doc/browser.html>Correctly Configure Netscape.</A>\n<BR>";
	    print TARGET "$normalligne\n";
	} else {
	    while (defined($LIGNEINP=<INPUT>)) {
		chop($LIGNEINP);
		$ligne .= &main::LatexBuiltinProcess($LIGNEINP)."\n";
	    }
	    print TARGET "$ligne\n";
	}
        print TARGET "<HR>\n";
        print TARGET "</BODY></HTML>\n";
        close(TARGET);
        close(INPUT);
    } else {
        push(@inputexclu,$file) ;
    }
}
#|#######################################################
sub OpenIndex {
# Dfinit un titre de code d'index.
    local($titre)=@_;
    local($ligne)="";
    if ($main::java) {
	$ligne="<HTML>
<HEAD>
<TITLE>$titre</TITLE>\n";
    unless ($main::opt_nostyle) {	
	$ligne .= "" . &fontify::stylesheet() ;
    }		
    $ligne .= "</HEAD>
<SCRIPT LANGUAGE=JAVASCRIPT>
function LienDynamique(document2){
   top.index.location=document2 ;
}
function LienJDynamique(document1,document2){
   top.source.location=document2 ;
   top.index.location=document1 ;
}
</SCRIPT>
<BODY BGCOLOR=WHITE LINK=BLUE ALINK=GREEN VLINK=#9910DD>
<H1 align=center>$titre</H1>
";
    } else {
	$ligne="<HTML>
<HEAD>
<TITLE>$titre</TITLE>\n";
    unless ($main::opt_nostyle) {	
	$ligne .= "".&fontify::stylesheet ;
    }		
    $ligne .= "</HEAD>
<SCRIPT LANGUAGE=JAVASCRIPT>
function LienDynamique(document2){
   top.index.location=document2 ;
}
</SCRIPT>
<BODY BGCOLOR=WHITE LINK=BLUE ALINK=GREEN VLINK=#9910DD>
<H1 align=center>$titre</H1>
";
    }
    return($ligne);
}
#|#######################################################
sub OpenSource {
# Dfinit un titre de code d'index.
    my($titre,$file,$target,$java)=@_;
    local($ligne)="";
    $ligne="<HTML>
<HEAD>
<BASE TARGET=\"$target\">
<TITLE>$titre</TITLE>\n";
    unless ($main::opt_nostyle) {	
	$ligne .= "".&fontify::stylesheet ;
    }		
    $ligne .= "</HEAD>
<SCRIPT LANGUAGE=JAVASCRIPT>
function LienDynamique(document2){
   top.index.location=document2 ;
}
function JavaDynamique(document2){
   top.source.location=document2 ;
}
</SCRIPT>
<BODY BGCOLOR=WHITE LINK=BLUE ALINK=GREEN VLINK=#9910DD>
<A NAME=R_$file></A>";
    if ($java) {
	$ligne .= "<H1 align=center><A Href=${file}LF.html TARGET=\"java\">$file</A></H1>\n";
    } else {
	$ligne .= "<H1 align=center>$file</H1>\n";
    }
    $ligne .= &main::last_modified($file) ;
    return($ligne);
}
#|#######################################################
sub OpenMainFrame {
# Dfinit les frames de base
    local($index,$source,$titre)=@_;
    local($ligne)="";
    if ($main::java) {
	$ligne = "<html>
<head>
   <title>$titre</title>\n";
    unless ($main::opt_nostyle) {	
	$ligne .= "".&fontify::stylesheet ;
    }		
    $ligne .= "</head>
<frameset COLS=\"25%,*\" BORDER=\"1\" MARGINHEIGHT=\"0\" MARGINWIDTH=\"0\">
<FRAMESET ROWS=\"50%,*\">
  <frame SRC=\"$index.html\" NAME=\"java\">
  <frame SRC=\"$index.html\" NAME=\"index\">
</FRAMESET> 
  <frame SRC=\"$source.html\" NAME=\"source\">
</frameset>
</html>" ;
    } else {
	$ligne = "<html>
<head>
   <title>$titre</title>\n";
    unless ($main::opt_nostyle) {	
	$ligne .= "".&fontify::stylesheet ;
    }		
    $ligne .= "</head>
<frameset COLS=\"25%,*\" BORDER=\"1\" MARGINHEIGHT=\"0\" MARGINWIDTH=\"0\">
  <frame SRC=\"$index.html\" NAME=\"index\">
  <frame SRC=\"$source.html\" NAME=\"source\">
</frameset>
</html>" ;
    }
    return($ligne);
}
#|#######################################################
sub Fontification_Html_Du_Tex {
    (@liste)=@_ ;
    (@inputexclu) = ();
    foreach $file (@liste) {
	($localFile,$a,$b)=&main::GetInfoRoutineCasei($file) ;
	$cible = &fichiers::InputFileOfWrite($a) ;
	&fichiers::GetInputCibleOfWrite($cible) ;
	$totalRoutine = $file ;
	&index::Input_Construct($localFile,$cible,$totalRoutine);
    }
    if (@inputexclu) {
	print "\n\tInput files not found: ".($#inputexclu+1)."\t";
	if ($main::debug) {
	    print "\n\t@inputexclu\n\t\t" ;
	}
    }
}
#|#######################################################
sub Index_Input {
# index des inputs
    open(MAINFRAME,">$main::DIRE/inpuindex.html");
    print MAINFRAME OpenMainFrame("leftindex","inpuindex_c","Index des inputs de $main::RepCodeSource");
    close(MAINFRAME);
# index code.
    open(INDEX,">$main::DIRE/inpuindex_c.html");
    print INDEX OpenIndex("Comments index on $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");
    @liste=sort keys %{main::latexinputed} ;
    $index_file = "$main::DIRE/inpuindex_c";
    print INDEX main::Build_Index_Chapter("source","index","Inputs","html",@liste);
    print INDEX &Index_Ferme("") ;
    close(INDEX);
} ;
#|#######################################################
sub OnJava {
    my($objet,$Routine,$java)=@_;
    return("<A HREF=\"${objet}_c.html#R_$Routine\" TARGET=\"source\">") unless $java ;
    return ("<A HREF=\"${objet}LF.html\" TARGET=\"java\" onClick=JavaDynamique(\"${objet}_c.html#R_$Routine\")>") ;
}
#|#######################################################
sub OnClick {
    local($cref,$tag,$index)=@_;
    if (($index) && ("$index" ne "")) {
	if (($tag) && ("$tag" ne "")) {
	    return(" onClick=LienDynamique(\"${cref}_i.html#$tag\")");
        } else {
	    return(" onClick=LienDynamique(\"${cref}_i.html\")");
	}
    } else {
	return("");
    }
}
#|#######################################################
sub OnJClick {
    local($cref,$tag,$index)=@_;
    if (($index) && ("$index" ne "")) {
	if (($tag) && ("$tag" ne "")) {
	    return(" onClick=LienJDynamique(\"${cref}_i.html#$tag\",\"${cref}_c.html#$tag\")");
        } else {
	    return(" onClick=LienJDynamique(\"${cref}_i.html\",\"${cref}_c.html\")");
	}
    } else {
	return("");
    }
}
#|#######################################################
# index des fichiers
sub Index_Fichiers {
    local($sources)=(@_) ;
    local(@listebis)=() ;
    open(MAINFRAME,">$main::DIRE/fileindex.html");
    print MAINFRAME OpenMainFrame("leftindex","fileindex_c","Index des fichiers de $main::RepCodeSource");
    close(MAINFRAME);
    open(INDEX,">$main::DIRE/fileindex_c.html");
    print INDEX OpenIndex("Files located on $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");
    local($source,$index)=("source","index");
    (@listebis)=() ;
    foreach $file (@{$sources}) {
	push(@listebis,&main::GetTotalRoutine($file)) ;
    }
    local($ok) = 1 ;
    $index_file = "$main::DIRE/fileindex_c";
    print INDEX main::Build_Index_Chapter("source","index","Source Files","html",@listebis);
    $ok = 0 ;
    (@listebis)=() ;
    foreach $file (keys %main::Include_Unique) {
	push(@listebis,&main::GetTotalInclude($file)) ;
    }
    print INDEX main::Build_Index_Chapter("source","index","Include Files","html",@listebis);
    print INDEX &Index_Ferme("") ;
    close(INDEX);
}
#|#######################################################
sub Index_Include {
# index des includes
    open(MAINFRAME,">$main::DIRE/inclindex.html");
    print MAINFRAME OpenMainFrame("leftindex","inclindex_c","Index des includes de $main::RepCodeSource");
    close(MAINFRAME);
# index code.
    open(INDEX,">$main::DIRE/inclindex_c.html");
    print INDEX OpenIndex("Includes index on $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");
    @liste=sort keys %{main::f90included} ;
    $index_file = "$main::DIRE/inclindex_c";
    print INDEX main::Build_Index_Chapter("source","index","Includes","html",@liste);
    print INDEX &Index_Ferme("") ;
    close(INDEX);
} ;
#|#######################################################
# Stolen from latex2html
sub get_date {
    local($format,$order) = @_;
    local(@lt) = localtime;
    local($d,$m,$y) = @lt[3,4,5];
    if ($format =~ /ISO/) {
	sprintf("%4d-%02d-%02d", 1900+$y, $m+1, $d);
    } elsif ($format) {
	if ($order) { eval "sprintf(".$format.",".$order.")"; }
	else { sprintf($format, $d, $m+1, 1900+$y); }
    } else { sprintf("%d/%d/%d", $m+1, $d, 1900+$y); }
}
#|#######################################################
sub address_data {
    local($user, $date, $_);
    local($format,$order) = @_;
    # Get author email address and current date.
    ($user = (getpwuid ($<))[6]) =~ s/,.*//;
    ($user, &get_date($format,$order));
}
#|#######################################################
sub Index_Index {
    local(@lt) = localtime;
    local($d,$m,$y) = @lt[3,4,5];
    @address_data = address_data('ISO');
    $lang = "en" ;
    if (exists $ENV{'LANG'}) {
	$lang = "fr" if ($ENV{'LANG'} =~ /fr/ ) ;
	$lang = "en" if ($ENV{'LANG'} =~ /en/ ) ;
    }
    open(MAINFRAME,">$main::DIRE/leftindex.html");
    print MAINFRAME "<HTML>
<HEAD>
<TITLE>Code $main::RepCodeSource de $main::USER.</TITLE>\n";
    unless ($main::opt_nostyle) {
	print MAINFRAME &fontify::stylesheet ;
    }		
    print MAINFRAME '</HEAD>
<BODY BGCOLOR=White LINK=BLUE ALINK=GREEN VLINK=#9910DD>
<H1>Code '.$main::RepCodeSource.' de '.$main::USER.'.</H1>
Traduction du code '.$main::RepCodeSource.' en HTML par
<A Href="http://cessenat.free.fr/pub/doc/index.html" TARGET=_top>ftagshtml</A>
le '. scalar localtime() .".
<BR>Please refer to manual or HTML help located at
<A Href=\"file:$ENV{FTAGSHTML_DIR}/doc/$lang/ftagshtml.html\" TARGET=_top>$lang/ftagshtml</A>
". &Index_Ferme("100") ;
#le '. $address_data[1].'.
#pour '. $address_data[0].'
#    foreach $t (getpwuid ($<)) { print "t=$t\n"; } ;
    close(MAINFRAME);
}
#|#######################################################
sub Index_Generic {
    my($indexfile,$title,$type,$emptytitle) = @_ ;
    open(MAINFRAME,">$main::DIRE/${indexfile}.html");
    print MAINFRAME OpenMainFrame("leftindex","${indexfile}_c","$title");
    close(MAINFRAME);
    local($lim) = 50 ; # NAJ: modify this value to a reasonable one !
    $lim = $main::opt_numperindex if $main::opt_numperindex ;
    if (@liste) {
	$lang = "html" ;
	if ($#liste+1 >= $lim) {
	    my(@sliste) = () ;
	    my $index_line = "";
	    my $imax = int($#liste / $lim)+1 ;
	    my ($localRoutine1,$localRoutine2,$localFile,$numdef) ;
	    for ($i = 0 ; $i< $imax ; $i++) {
		@sliste = @liste[$i*$lim..min($i*$lim+$lim-1,$#liste)] ;
		$index_line .= "<P><A Href=\"${indexfile}_c$i.html\">Index $i</A>:\n";
		($localRoutine1,$localFile,$numdef) = main::GetInfoRoutine ($sliste[0]) ;
		($localRoutine2,$localFile,$numdef) = main::GetInfoRoutine ($sliste[$#sliste]) ;
		$index_line .= "From ";
#		$index_line .= "$localRoutine1";
# What a chance ! This is coherent with what "Build_Index_Chapter" makes in html !
		$index_line .= "<A Href=\"${indexfile}_c$i.html#R_$localRoutine1\">$localRoutine1</A>, \n";
		$index_line .= " to ";
#		$index_line .= "$localRoutine2";
		$index_line .= "<A Href=\"${indexfile}_c$i.html#R_$localRoutine2\">$localRoutine2</A>, \n";
		$index_line .= " through \n";
		$stop = 1 ;
		for ($j=1; $j < $#sliste; $j++) {
		    my($localRoutine,$localFile,$numdef) = main::GetInfoRoutine ($sliste[$j]) ;
		    $stop = 0 if (exists $main::process{$localFile}) ;
#		    $index_line .= "$localRoutine, \n";
		    $index_line .= "<A Href=\"${indexfile}_c$i.html#R_$localRoutine\">$localRoutine</A>, \n";
		}
		chop($index_line) ;chop($index_line) ;chop($index_line) ;
		$index_line .= ".\n";
		unless ($stop) {
		    $index_file = "$main::DIRE/${indexfile}_c";
		    open(INDEX,">$main::DIRE/${indexfile}_c$i.html");
		    print INDEX OpenIndex("$title");
		    print INDEX main::En_Tete_All("","none","source");
		    if ($i < $imax-1) {
			print INDEX "<BR><A Href=\"${indexfile}_c".($i+1).".html\">Next Index ".($i+1)."</A>\n";
		    }
		    if ($i) {
			print INDEX "<BR><A Href=\"${indexfile}_c".($i-1).".html\">Previous Index ".($i-1)."</A>\n";
		    }
		    print INDEX main::Build_Index_Chapter("source","index","$type",$lang,@sliste);
		    if ($i < $imax-1) {
			print INDEX "<BR><A Href=\"${indexfile}_c".($i+1).".html\">Next Index ".($i+1)."</A>\n";
		    }
		    if ($i) {
			print INDEX "<BR><A Href=\"${indexfile}_c".($i-1).".html\">Previous Index ".($i-1)."</A>\n";
		    }
		    print INDEX &Index_Ferme("") ;
		    close(INDEX);
		}
	    }
	    open(INDEX,">$main::DIRE/${indexfile}_c.html");
	    print INDEX OpenIndex("$title");
	    print INDEX main::En_Tete_All("","none","source");
	    print INDEX $index_line ;
	    print INDEX &Index_Ferme("") ;
	    close(INDEX);
	} else {
	    $index_file = "$main::DIRE/${indexfile}_c";
	    open(INDEX,">$main::DIRE/${indexfile}_c.html");
	    print INDEX OpenIndex("$title");
	    print INDEX main::En_Tete_All("","none","source");
	    print INDEX main::Build_Index_Chapter("source","index","$type",$lang,@liste);
	    print INDEX &Index_Ferme("") ;
	    close(INDEX);
	}
    } else {
	open(INDEX,">$main::DIRE/${indexfile}_c.html");
	print INDEX OpenIndex("$title");
	print INDEX main::En_Tete_All("","none","source");
	print INDEX "<H1>$emptytitle</H1>\n";
	print INDEX &Index_Ferme("") ;
	close(INDEX);
    }
} ;
#|#######################################################
sub min {
    my $min = shift(@_);
    foreach $foo (@_) {
	$min = $foo if $min > $foo;
    }
    return $min;
}
#|#######################################################
sub onMouseOver {
    my($TypeMessage) = @_ ;
    return (" onMouseOver=\"window.status='Index of $TypeMessage, code $main::RepCodeSource.'; return true\"");
}
#|#######################################################
sub Index_Principal {
    $lang = "html";
    (%affiche)=(main::TalkInLaTeXOrHtml($lang,%main::delegue));
    &Index_Index;
    open(MAINFRAME,">$main::DIRE/progindex.html");
    print MAINFRAME OpenMainFrame("leftindex","progindex_c","Index des programmes de $main::RepCodeSource");
    close(MAINFRAME);
# index code.
    open(INDEX,">$main::DIRE/progindex_c.html");
    print INDEX OpenIndex("Main programmes index on $main::RepCodeSource");
    print INDEX main::En_Tete_All("","none","source");
    (@liste)=(sort keys %main::programmes);
    if (@liste) {
	$lang = "html" ;
	$index_file = "$main::DIRE/progindex_c";
	print INDEX main::Build_Index_Chapter("source","index","Programmes",$lang,@liste);
    } else {
	print INDEX "<H1>No main entry point in $main::RepCodeSource.</H1>\n";
    }
    print INDEX &Index_Ferme("") ;
    close(INDEX);
}
#|#######################################################
sub Index_Routines {
    open(MAINFRAME,">$main::DIRE/routindex.html");
    print MAINFRAME OpenMainFrame("leftindex","routindex_c","Index of the subroutines of $main::RepCodeSource");
    close(MAINFRAME);
# index code.
    local(@liste)=(sort keys %main::routines) ;
    &Index_Generic("routindex","Index of the subroutines of $main::RepCodeSource","Routines","No subroutine in $main::RepCodeSource") ;
}
#|#######################################################
sub Index_Fonctions {
    open(MAINFRAME,">$main::DIRE/foncindex.html");
    print MAINFRAME OpenMainFrame("leftindex","foncindex_c","Index of the functions of $main::RepCodeSource");
    close(MAINFRAME);
# index code.
    local(@liste)=(sort keys %main::functions) ;
    &Index_Generic("foncindex","Index of the functions of $main::RepCodeSource","Functions","No function in $main::RepCodeSource") ;
}
#|#######################################################
sub Index_Modules {
    open(MAINFRAME,">$main::DIRE/moduleindex.html");
    print MAINFRAME OpenMainFrame("leftindex","moduleindex_c","Index of the modules of $main::RepCodeSource");
    close(MAINFRAME);
# index code.
    local(@liste)=(sort keys %main::module) ;
    &Index_Generic("moduleindex","Index of the modules of $main::RepCodeSource","Modules","No module in $main::RepCodeSource") ;
}
#|#######################################################
sub Gere_Index {
    local($totalRoutine)=main::GetTotalRoutine($nom) ;
    $ligne  = &{$affiche{"Private_Called"}}($totalRoutine,"source","index") ;
    $ligne .= &{$affiche{"Private_Calls"}}($totalRoutine,"source","index") ;
    print INDEX "$ligne";
} ;
#|#######################################################
sub Index_Ferme {
# fermeture des fichiers HTML
    my($reduce) = @_ ;
    my($ligne) = "";
    my($user) = "";
    ($user = (getpwuid ($<))[6]) =~ s/,.*//;
    $user = $ENV{USER} unless $user ;
    $user = $ENV{LOGNAME} unless $user ;
    my(@lt) = localtime();
    my($d,$m,$y) = @lt[3,4,5];
    $y += 1900 ; $m++ ;
    $ligne .= "<IMG SRC=\"ftagshtml.jpg\"";
    if ($reduce) {
	$ligne .= " WIDTH=\"$reduce%\"";
    }
    $ligne .= " ALT=\"ftagshtml's logo\"";
    $ligne .= ">\n";
    $ligne .= "<BR>Code $main::RepCodeSource, ";
    $ligne .= "Using ftagshtml-$main::version, " ;
    $ligne .= "Generated by $user, " if $user ;
    $ligne .= "At $d /$m /$y.\n";
    $ligne .= "</BODY></HTML>\n";
    return($ligne) ;
} ;
#|#######################################################
1;
