package information;
#|########################################################################
# ftagshtml: transforms fortran and C source into HTML or PostScript or PDF.
#    Copyright (C) 2000 Olivier Cessenat.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#|########################################################################
sub information {
    $lang = "en" ;
    if (exists $ENV{'LANG'}) {
	$lang = "fr" if ($ENV{'LANG'} =~ /fr/ ) ;
	$lang = "en" if ($ENV{'LANG'} =~ /en/ ) ;
    }
    if ($lang eq "fr") {	    
	print STDOUT <<'INFORMATION';
Message en langue $lang d'aprs votre locale

Objet:
      Mise sous forme HTML et sous forme d'un index LaTeX des fichiers
      fortran $77$, fortran $90$, c et c$++$ ainsi que des include.

Description:
      Liste les includes C et fortran, les appels dfinis par 'call' en
      fortran, les appels et dfinitions des fonctions C et fortran,
      les subroutines fortran, les commentaires donns par le code
      '\input' en minuscule, constitue un index des fichiers, des
      fonctions et routines dfinies, des includes...

Arguments:
      -debug: option pour gnrer un bug report aux auteurs.
      -f90: les programmes d'extension .f seront considrs comme du
	    fortran 90.
      -hevea: utilisation du traducteur de LaTeX en HTML pour les fichiers
	  input.
      -I string: liste des rpertoires o chercher les fichiers includes.
      -l2h: produit un fichier de rfrence d'tiquettes pour latex2html.
      -latex: si vos commentaires sont en LaTeX partout dans le code.
      -latexindex: gnration d'un index LaTeX
      -nocolor: pas de colorisation (obsolte depuis l'apparition des styles CSS 1)
      -nofile: n'affiche pas le nom de la routine ou fonction en cours.
      -nojava: inhibe la gnration des arbres javascript.
      -nolinenum: n'affiche pas le numro de ligne du fichier.
      -nostyle: n'utilise pas les feulles de style CSS 1 pour la fontification
	  (auquel cas l'option 'nocolor' peut servir)
      -numperindex int: limite le nombre d'lments des index de routines,
	  fonctions et modules  int.
      -t: rpertoire sur lequel les sources doivent rester de faon
          permanente.
      -v integer: donne des informations supplmentaires  l'excution.
      -version: affiche le numro de version
      -u: utilise le sparateur HTML <hr>
      -w: rpertoire d'criture.
          Ce rpertoire doit tre inexistant avant l'appel de ftagshtml.
      *.f: fichiers fortran
      *.c: fichiers C

Options conseills:
      Dans le cas gnral:
          ftagshtml -latexindex *.f *.c
      Dans le cas d'une programmation littraire avec des commentaires
      en LaTeX:
          ftagshtml -latexindex -hevea -l2h *.f *.c
          cd HTML/ftagshtml
          latex Sindex && latex Sindex && dvips -f Sindex.dvi -o Sindex.ps
          pdflatex Sindex
      Les options -w et -I sont videmment une question de gestion du
      code. Elles ne sont ni conseilles ni dconseilles.

Bugs:
      en C:
        - Dfinition de sous programme priv  l'intrieur d'un programme.
        - Surcharge de sous-programmes.
        - Utilisation de pointeurs de fonctions.
      en Fortran 77:
	- A sgnaler.
      en Fortran 90:
	- A sgnaler.

Auteur:
      Olivier Cessenat <cessenat.free.fr>
      http://cessenat.free.fr/pub/doc/ftagshtml.html

Plus d'infos:
    Consultez la page de manuel en Anglais  l'adresse
INFORMATION
    print STDOUT "\tnetscape -remote 'openURL(file:$ENV{FTAGSHTML_DIR}/doc/$lang/ftagshtml.html)' &\n"
    } else {
        print STDOUT "\tPlease refer to manual or HTML help located at\n";
        print STDOUT "\tnetscape -remote 'openURL(file:$ENV{FTAGSHTML_DIR}/doc/$lang/ftagshtml.html)' &\n"
   }
}

1;
