package restart;
#|#######################################################
# To do:
# Stage 1:
# Must determine files to analyze at level 2 (@addfiles,@destroyfiles)
# and remove all susequent entries for @destroyfiles and their points.
# At this stage, we know we shall have to reprocess some files that were called
# or used ou inputed or included: array names are @restartcall, @restartinput
# and @restartinclude.
# These are files to reHtml.
#
# Stage 2:
# Must determine supplementary files to reprocess since either they
# are new (inputs or includes) or since they changed.
# These files will be processed by GetFilesAndInclude.
# Their definitions must be erased.
#
# Stage 3: reprocessing
# We should know which files to reprocess in arrays listef90 and listehf90.
#
# Index processing:
# For all entries of all indexes, an array should say if they have to be reprocessed.
# If not, their entry should be found in the previous index.
#
# Bugs: probably many restarting with fortran 90 files.
# An issue could be to touch higher level files and thus to refresh all
# the associated data. Normally, this should work well.
#|#######################################################
sub DestroyRecursiveDefinitions {
    while ((@sayval)=&destroy_key_in_hash_sayvalue(\@lowdestroydefs,\%{main::sons})) {
	push(@lowdestroydefs,@sayval);
    }
}
#|#######################################################
sub GetRecursiveDefinitions {
    return(&recursive_key_in_hash_sayvalue(\@highdestroydefs,\%{main::sons})) ;
}
#|#######################################################
sub destroysubentries {
# We must also destroy entries of files that changed (we should)
# Or better, renew entries of files that are no longer used later on.
    (@highdestroydefs) = &gethighpoints(\@destroyfiles) ;
    print INFO "\t\t1) Deleting entries: highdestroydefs=\n" if $debug;
    &PrintDebug(2,\@highdestroydefs) if $debug;
    foreach $upproc (@highdestroydefs) {
	local($localProc,$localFile,$localNum) = &main::GetInfoRoutine($upproc) ;
	push(@highdefprocedures,$localProc) ;
    }
    print INFO "\t\t1) Public definitions removed highdefprocedures=\n" if ($debug);
    &PrintDebug(2,\@highdefprocedures) if $debug;

    print INFO "\t\t1) Array lfichiers cleaned from destroyfiles.\n" if ($debug) ;
    &destroy_key_in_hash(\@destroyfiles,\%main::lfichiers) ;

    print INFO "\t\t1) Array programmes cleaned from highdestroydefs.\n" if ($debug) ;
    &destroy_key_in_hash(\@highdestroydefs,\%main::programmes) ;

    print INFO "\t\t1) Array functions cleaned from highdestroydefs.\n" if ($debug) ;
    &destroy_key_in_hash(\@highdestroydefs,\%main::functions) ;

    print INFO "\t\t1) Array routines cleaned from highdestroydefs.\n" if ($debug) ;
    &destroy_key_in_hash(\@highdestroydefs,\%main::routines) ;

    print INFO "\t\t1) Array module cleaned from highdestroydefs.\n" if ($debug) ;
    &destroy_key_in_hash(\@highdestroydefs,\%main::module) ;

    print INFO "\t\t1) Destroying highdestroydefs: Appellees-Appelants.\n" if ($debug) ;
    &destroy_dual_pure(\@highdestroydefs,\%main::Appellees,\%main::Appelants) ;

    (@lowdestroydefs) = () ;
    push(@lowdestroydefs,@highdestroydefs);
    &DestroyRecursiveDefinitions ;
    print INFO "\t\t1) Public and private definitions to remove: lowdestroydefs=\n" if ($debug) ;
    &PrintDebug(2,\@lowdestroydefs) if $debug;

    &destroy_subdual_files(\@lowdestroydefs,\%{main::realcalls},\%{main::realcalled});
    (@restart3file) = (keys %new_file);
    print INFO "\t\t1) Called files to rehtml are restart3file=\n" if ($debug);
    &PrintDebug(2,\@restart3file) if $debug;

    &destroy_dual_files(\@lowdestroydefs,\%{main::realuses},\%{main::realused});
    (@restart3file) = (keys %new_file);
    print INFO "\t\t1) Called and Moduled files to rehtml are restart3file=\n" if ($debug);
    &PrintDebug(2,\@restart3file) if $debug;

    print INFO "\t\t1) Array L_Declar cleaned from highdestroydefs.\n" if ($debug) ;
    &destroy_key_in_hash(\@highdefprocedures,\%main::L_Declar) ;

    print INFO "\t\t1) Array R_Declar cleaned from highdestroydefs.\n" if ($debug) ;
    &destroy_key_in_hash(\@highdefprocedures,\%main::R_Declar) ;

    print INFO "\t\t1) Array File_Of_Rout cleaned from highdestroydefs.\n" if ($debug) ;
    &destroy_key_in_hash(\@highdefprocedures,\%main::File_Of_Rout) ;

    print INFO "\t\t1) Array File_Of_Rout cleaned from destroyfiles.\n" if ($debug) ;
    &destroy_key_in_hash(\@destroyfiles,\%main::File_Of_Rout) ;

    print INFO "\t\t1) Array father cleaned from lowdestroydefs.\n" if ($debug) ;
    &destroy_key_in_hash(\@lowdestroydefs,\%{main::father}) ;

    print INFO "\t\t1) Destroying 'lowdestroydefs' keys in f90includes.\n" if ($debug) ;
    &destroy_dual_includes(\@lowdestroydefs,\%{main::f90includes},\%{main::f90included});
    (@restart3include) = (keys %new_include) ;
    print INFO "\t\t1) Includes to Rehtml are restart3include=\n" if ($debug) ;
    &PrintDebug(2,\@restart3include) if $debug;

    print INFO "\t\t1) Destroying 'lowdestroydefs' keys in latexinputs.\n" if ($debug) ;
    &destroy_dual_inputs(\@lowdestroydefs,\%{main::latexinputs},\%{main::latexinputed});
    (@restart3input) = (keys %new_input) ;
    print INFO "\t\t1) Inputs to Rehtml are restart3input=\n" if ($debug) ;
    &PrintDebug(2,\@restart3input) if $debug;

    print INFO "\t\t1) Array available cleaned from lowdestroydefs.\n" if ($debug) ;
    &destroy_key_in_hash(\@lowdestroydefs,\%{main::available}) ;

    print INFO "\t\t1) Array effectcalled cleaned from lowdestroydefs.\n" if ($debug) ;
    &destroy_key_in_hash(\@lowdestroydefs,\%{main::effectcalled}) ;

    print INFO "\t\t1) Removing labels for destroyfiles.\n" if $debug;
    &SuppressLabel(\@destroyfiles) ;

#NAJ: we still must remove entries for includes and inputs.
# All the stuff linked with that should be destroyed.
    &GetListeh(0,@restart2include) ;
    print INFO "\t\t1) Destroying 'restart2include' keys in f90includes.\n" if ($debug) ;
    &destroy_dual_includes(\@restart2include,\%{main::f90includes},\%{main::f90included});
    (@restart3include) = (keys %new_include) ;
    print INFO "\t\t1) Includes to Rehtml are restart3include=\n" if ($debug) ;
    &PrintDebug(2,\@restart3include) if $debug;

    (%already_suppressed) = () ;
    foreach $totalInclude (@restart2include) {
	($a,$file,$b) = &main::GetInfoRoutineCasei($totalInclude) ;
	$already_suppressed{$file} = 1 ;
    }
    (@a) = (keys %already_suppressed) ;
    &SuppressLabel(\@a) ;
#NAJ: destroy all attributes of an include...

    print INFO "\t\t1) Destroying 'restart2input' keys in latexinputs.\n" if ($debug) ;
    &destroy_dual_inputs(\@restart2input,\%{main::latexinputs},\%{main::latexinputed});
    (@restart3input) = (keys %new_input) ;
    print INFO "\t\t1) Inputs to Rehtml are restart3input=\n" if ($debug) ;
    &PrintDebug(2,\@restart3input) if $debug;

    (%already_suppressed) = () ;
    foreach $totalInput (@restart2input) {
	($a,$file,$b) = &main::GetInfoRoutineCasei($totalInput) ;
	$already_suppressed{$file} = 1 ;
    }
    (@a) = (keys %already_suppressed) ;
    &SuppressLabel(\@a) ;

    print INFO "\t\t1) Achieved destroysubentries.\n" if ($debug) ;

}
#|#######################################################
sub addsubentries {
# Status: seems OK for destroying entries and called entries.
    (@highdestroydefs) = &gethighpoints(\@destroyfiles) ;
    (@highdefprocedures) = () ;
    print INFO "\t\t2) High entries: highdestroydefs=\n" if $debug;
    &PrintDebug(2,\@highdestroydefs) if $debug;
    foreach $upproc (@highdestroydefs) {
	local($localProc,$localFile,$localNum) = &main::GetInfoRoutine($upproc) ;
	push(@highdefprocedures,$localProc) ;
    }
    print INFO "\t\t2) Public definitions added highdefprocedures=\n" if ($debug);
    &PrintDebug(2,\@highdefprocedures) if $debug;

    (@lowdestroydefs) = &GetRecursiveDefinitions ;
    print INFO "\t\t2) Public and private definitions to remove: lowdestroydefs=\n" if ($debug) ;
    &PrintDebug(2,\@lowdestroydefs) if $debug;

    &get_subdual_files(\@lowdestroydefs,\%{main::realcalls},\%{main::realcalled});
    (@restart3file) = (keys %new_file);
    print INFO "\t\t2) Called files to rehtml are restart3file=\n" if ($debug);
    &PrintDebug(2,\@restart3file) if $debug;
    &get_dual_files(\@lowdestroydefs,\%{main::realuses},\%{main::realused});
    (@restart3file) = (keys %new_file);
    print INFO "\t\t2) Called and Moduled files to rehtml are restart3file=\n" if ($debug);
    &PrintDebug(2,\@restart3file) if $debug;

    print INFO "\t\t2) Getting 'lowdestroydefs' keys in f90includes.\n" if ($debug) ;
    &get_dual_includes(\@lowdestroydefs,\%{main::f90includes},\%{main::f90included});
    (@restart3include) = (keys %new_include) ;
    print INFO "\t\t2) Includes to Rehtml are restart3include=\n" if ($debug) ;
    &PrintDebug(2,\@restart3include) if $debug;

    print INFO "\t\t2) Getting 'lowdestroydefs' keys in latexinputs.\n" if ($debug) ;
    &get_dual_inputs(\@lowdestroydefs,\%{main::latexinputs},\%{main::latexinputed});
    (@restart3input) = (keys %new_input) ;
    print INFO "\t\t2) Inputs to Rehtml are restart3input=\n" if ($debug) ;
    &PrintDebug(2,\@restart3input) if $debug;

}
#|#######################################################
sub UpdateCallers {
    while (($cle1,$a) = each %new_point) {
	if (exists $main::realcalls{$cle1}) {
	    while (($cle2,$cle3) = each %{$main::realcalls{$cle1}}) {
		$cle4 = &main::GetTotalRoutine($cle2) ;
		($a,$file,$b) = &main::GetInfoRoutineCasei($cle4) ;
		if ("$a:$file:$b" eq "$cle4") {
		    ${$main::realcalls{$cle1}}{$cle2} = $cle4 ;
		    ${$main::realcalled{$cle4}}{$cle1} = $cle2 ;
		}
	    }
	}
    }
}
#|#######################################################
sub GetDestroyAddFiles {
# Get files to destroy as well as new files to fully process
    (@addfiles) = () ;
    (@destroyfiles) = () ;
    my(%tab) = () ;
    foreach $file (@ARGV) {
	next if $tab{$file} ;
	@mx = stat $file ;
	if ($mx[9] > $main::currenttime ) {
	    push(@destroyfiles,$file) ;
	} else {
	    unless (exists $main::File_Of_Rout{"$file"}) {
		push(@addfiles,$file) ;
	    }
	}
	$tab{$file} = 1 ;
    }
    (%tab) = () ;
}
#|#######################################################
sub StageRestartDefinition {
    local(*INFO) = "main::INFO_Definition" ;
    print INFO "\t1) Start of analysis.\n" if $debug;
    $debug = $main::debug ;
    if ( $main::currentversion < $main::requireversion) {
	print STDERR "Version from previous run is too old.\n";
	print STDERR "Previous run version is $main::currentversion whereas the required version is at leat $main::requireversion\n";
	print STDERR "Remove $main::DIRE/ftagshtml.info first.\n";
	exit(1) ;
    }
# The list of objects to destroy:
# lfichiers gives the list of definitions of points to suppress,
# f90includes gives the list of includes from the points of destroylist
# that are to be suppressed
# Get files to destroy as well as new files to fully process
# Output is destroyfiles and addfiles
    &GetDestroyAddFiles ;
    print INFO "\t1) Source files that changed are: destroyfiles=\n" if $debug;
    &PrintDebug(1,\@destroyfiles) if $debug;
    print INFO "\t1) Source files that are unknown: addfiles=\n" if $debug;
    &PrintDebug(1,\@addfiles) if $debug;
# Output is restart2include
    &GetChangedIncludes ;
    print INFO "\t1) Include files that changed are: restart2include=\n" if $debug;
    &PrintDebug(1,\@restart2include) if $debug;
# Output is restart2input
    &GetChangedInputs ;
    print INFO "\t1) Input files that changed are: restart2input=\n" if $debug;
    &PrintDebug(1,\@restart2input) if $debug;
    &GetListet(0,@restart2input) ;
#Not really clever method, but should work...
    print INFO "\t1) Removing destroysubentries for destroyfiles.\n" if $debug;
    &restart::destroysubentries ;
    print INFO "\t1) Determining types for destroyfiles and addfiles.\n" if $debug;
    &main::Determine_Types(@destroyfiles,@addfiles) ;
    print INFO "\t1) End of analysis.\n" if $debug;
}
#|#######################################################
sub StageRestartCallInclude {
# We must determine the files that now are called and that were not previously.
    local(*INFO) = "main::INFO_Include" ;
    print INFO "\t2) Start of analysis.\n" if $debug;
    $debug = $main::debug ;
    &GetListeh(0,@restart2include) ;
    &restart::addsubentries ;
    print INFO "\t2) End of analysis.\n" if $debug;
}
#|#######################################################
sub Unique {
    my($a) = @_ ;
    my(@b) = () ;
    my(%tab) = () ;
    foreach $t (@$a) {
	unless (exists $tab{$t}) {
	    $tab{$t} = 1 ;
	    push(@b,$t) ;
	}
    }
    (%tab) = () ;
    return(@b) ;
}
#|#######################################################
sub GetChangedIncludes {
    (@restart2include) = () ;
    my(@liste) = () ;
    (@liste)=sort keys %{main::f90included} ;
    foreach $file (@liste) {
	($a,$file_read,$b)=&main::GetInfoRoutineCasei($file) ;
	if ($file_read) {
	    @mx = stat $file_read ;
	    if ($mx[9] > $main::currenttime ) {
		push(@restart2include,$file) ;
	    } 
	}
    }
}
#|#######################################################
sub GetTexRefresh {
    my(%tab) = () ;
    foreach $file (@main::listetex) {
	$tab{$file} = 1 ;
    }
    foreach $file (@restart2input) {
	if ((exists $main::f90inputed{$file}) && (%{$main::f90inputed{$file}})) {
	    $tab{$file} = 1 ;
	}
    }
    (@main::listetex) = (keys %tab) ;
    (%tab) = () ;
}
#|#######################################################
sub GetChangedInputs {
    (@restart2input) = () ;
    my(@liste) = () ;
    (@liste)=sort keys %{main::f90inputed} ;
    foreach $file (@liste) {
	($a,$file_read,$b)=&main::GetInfoRoutineCasei($file) ;
	if ($file_read) {
	    @mx = stat $file_read ;
	    if ($mx[9] > $main::currenttime ) {
		push(@restart2input,$file) ;
	    } 
	}
    }
}
#|#######################################################
sub GetListeh {
    my($level,@files) = @_ ;
    foreach $file (@files) {
	($a,$globalInclude,$b) = &main::GetInfoRoutineCasei($file) ;
	unless ((!$globalInclude) || ($main::I_Include{$globalInclude})) {
	    $type = $main::R_Include{$globalInclude} if exists $main::R_Include{$globalInclude} ;
	    unless ($type) {
		print "R_Include undefined on '$globalInclude'\n" ;
		while (($totalRoutine,$b) = each %{$main::f90included{$file}}) {
		    ($localRoutine,$localFile,$localNum) = &main::GetInfoRoutineCasei($totalRoutine) ;
		    $type = &main::Say_Type($localFile) ;
		    last ;
		}
	    }
	    if ($type) {
		push(@{"main::listeh$type"},$globalInclude) ;
		$main::I_Include{$globalInclude} = $level ;
	    }
	}
    }
}
#|#######################################################
sub gethighpoints {
    my($files) = @_ ;
    my(@points) = () ;
    foreach $file (@$files) {
	if (exists $main::lfichiers{$file}) {
	    push(@points,@{$main::lfichiers{$file}}) ;
        }
    }
    return(@points) ;
}
#|#######################################################
sub SuppressLabel {
    my($files) = @_ ;
    foreach $file (@$files) {
	if (exists $main::revlab{$file}) {
	    foreach $lab (@{$main::revlab{$file}}) {
		delete $main::label{$lab} ;
	    }
	    delete $main::revlab{$file} ;
	}
    }
}
#|#######################################################
sub destroy_dual_pure {
    my($listetodestroy,$array,$dual) = @_ ;
    foreach $cle1 (@$listetodestroy) {
	if (exists $$array{"$cle1"}) {
	    foreach $cle2 (keys %{$$array{"$cle1"}}) {
		delete ${$$dual{$cle2}}{$cle1} if exists ${$$dual{$cle2}}{$cle1} ;
            }
        }
    }
    foreach $cle1 (@$listetodestroy) {
	delete $$array{"$cle1"} if exists $$array{"$cle1"} ;
    }
}
#|#######################################################
sub get_dual_files {
# Destruction niveau 1 des tableaux d'appel et mmorisation
# dans new_file et new_point
    my($listetodestroy,$array,$dual) = @_ ;
    foreach $cle1 (@$listetodestroy) {
	if (exists $$dual{"$cle1"}) {
	    foreach $cle2 (keys %{$$dual{"$cle1"}}) {
		if (exists ${$$dual{$cle1}}{$cle2}) {
		    $new_point{$cle2} = 1 unless exists $new_point{$cle2} ;
		    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle2) ;
		    if ($fic) {
			$new_file{$fic} = 1 unless exists $new_file{$fic} ;
		    }
	        }
            }
        }
    }
    foreach $cle1 (@$listetodestroy) {
	if (exists $$array{"$cle1"}) {
	    foreach $cle2 (keys %{$$array{"$cle1"}}) {
		if (exists ${$$dual{$cle2}}{$cle1}) {
		    $new_point{$cle2} = 1 unless exists $new_point{$cle2} ;
		    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle2) ;
		    if ($fic) {
			$new_file{$fic} = 1 unless exists $new_file{$fic} ;
		    }
	        }
            }
        }
    }
    foreach $cle1 (@$listetodestroy) {
        if (exists $$array{"$cle1"}) {
	    $new_point{$cle1} = 2 ;
	    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle1) ;
	    $new_file{$fic} = 2 if $fic ;
	}
    }
}
#|#######################################################
sub get_subdual_files {
# subdual means array{key1}{key2} points to a valid key2 key for dual array
    my($listetodestroy,$array,$dual) = @_ ;
    foreach $cle1 (@$listetodestroy) {
	if (exists $$dual{"$cle1"}) {
	    foreach $cle2 (keys %{$$dual{"$cle1"}}) {
		if (exists ${$$dual{$cle1}}{$cle2}) {
		    $new_point{$cle2} = 1 unless exists $new_point{$cle2} ;
		    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle2) ;
		    if ($fic) {
			$new_file{$fic} = 1 unless exists $new_file{$fic} ;
		    }
	        }
            }
        }
    }
    foreach $cle1 (@$listetodestroy) {
	if (exists $$array{"$cle1"}) {
	    foreach $cle2 (keys %{$$array{"$cle1"}}) {
	        $cle2v = ${$$array{$cle1}}{$cle2} ;
		if (exists ${$$dual{$cle2v}}{$cle1}) {
		    $new_point{$cle2v} = 1 unless exists $new_point{$cle2v} ;
		    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle2v) ;
		    if ($fic) {
			$new_file{$fic} = 1 unless exists $new_file{$fic} ;
		    }
	        }
            }
        }
    }
    foreach $cle1 (@$listetodestroy) {
        if (exists $$array{"$cle1"}) {
	    $new_point{$cle1} = 2 ;
	    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle1) ;
	    $new_file{$fic} = 2 if $fic ;
	}
    }
}
#|#######################################################
sub destroy_dual_files {
# Destruction niveau 1 des tableaux d'appel et mmorisation
# dans new_file et new_point
    my($listetodestroy,$array,$dual) = @_ ;
    foreach $cle1 (@$listetodestroy) {
	if (exists $$dual{"$cle1"}) {
	    foreach $cle2 (keys %{$$dual{"$cle1"}}) {
		if (exists ${$$dual{$cle1}}{$cle2}) {
		    $new_point{$cle2} = 1 unless exists $new_point{$cle2} ;
		    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle2) ;
		    if ($fic) {
			$new_file{$fic} = 1 unless exists $new_file{$fic} ;
		    }
##		    delete ${$$dual{$cle1}}{$cle2} ;
	        }
            }
        }
    }
    foreach $cle1 (@$listetodestroy) {
	if (exists $$array{"$cle1"}) {
	    foreach $cle2 (keys %{$$array{"$cle1"}}) {
		if (exists ${$$dual{$cle2}}{$cle1}) {
		    $new_point{$cle2} = 1 unless exists $new_point{$cle2} ;
		    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle2) ;
		    if ($fic) {
			$new_file{$fic} = 1 unless exists $new_file{$fic} ;
		    }
		    delete ${$$dual{$cle2}}{$cle1} ;
	        }
            }
        }
    }
    foreach $cle1 (@$listetodestroy) {
        if (exists $$array{"$cle1"}) {
	    $new_point{$cle1} = 2 ;
	    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle1) ;
	    $new_file{$fic} = 2 if $fic ;
	    delete $$array{"$cle1"} 
	}
    }
}
#|#######################################################
sub destroy_subdual_files {
# Destruction niveau 1 des tableaux d'appel et mmorisation
# dans new_file et new_point
    my($listetodestroy,$array,$dual) = @_ ;
    foreach $cle1 (@$listetodestroy) {
	if (exists $$dual{"$cle1"}) {
	    foreach $cle2 (keys %{$$dual{"$cle1"}}) {
		if (exists ${$$dual{$cle1}}{$cle2}) {
		    $new_point{$cle2} = 1 unless exists $new_point{$cle2} ;
		    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle2) ;
		    if ($fic) {
			$new_file{$fic} = 1 unless exists $new_file{$fic} ;
		    }
	        }
            }
        }
    }
    foreach $cle1 (@$listetodestroy) {
	if (exists $$array{"$cle1"}) {
	    foreach $cle2 (keys %{$$array{"$cle1"}}) {
	        $cle2v = ${$$array{$cle1}}{$cle2} ;
		if (exists ${$$dual{$cle2v}}{$cle1}) {
		    $new_point{$cle2v} = 1 unless exists $new_point{$cle2v} ;
		    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle2v) ;
		    if ($fic) {
			$new_file{$fic} = 1 unless exists $new_file{$fic} ;
		    }
		    delete ${$$dual{$cle2v}}{$cle1} ;
	        }
            }
        }
    }
    foreach $cle1 (@$listetodestroy) {
        if (exists $$array{"$cle1"}) {
	    $new_point{$cle1} = 2 ;
	    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle1) ;
	    $new_file{$fic} = 2 if $fic ;
	    delete $$array{"$cle1"} 
	}
    }
}
#|#######################################################
sub get_dual_includes {
# Destruction niveau 1 des tableaux d'appel et mmorisation
# dans new_include et new_point
    my($listetodestroy,$array,$dual) = @_ ;
    if (0) { # No need to update callers of includes.
    foreach $cle1 (@$listetodestroy) {
	if (exists $$dual{"$cle1"}) {
	    foreach $cle2 (keys %{$$dual{"$cle1"}}) {
		if (exists ${$$dual{$cle1}}{$cle2}) {
		    $new_point{$cle2} = 1 unless exists $new_point{$cle2} ;
		    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle2) ;
		    if ($fic) {
			$new_include{$fic} = 1 unless exists $new_include{$fic} ;
			$new_inc_point{$cle2} = 1 ;
		    }
	        }
            }
        }
    }
    }
    foreach $cle1 (@$listetodestroy) {
	if (exists $$array{"$cle1"}) {
	    foreach $cle2 (keys %{$$array{"$cle1"}}) {
		if (exists ${$$dual{$cle2}}{$cle1}) {
		    $new_point{$cle2} = 1 unless exists $new_point{$cle2} ;
		    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle2) ;
		    if ($fic) {
			$new_include{$fic} = 1 unless exists $new_include{$fic} ;
			$new_inc_point{$cle2} = 1 ;
		    }
	        }
            }
        }
    }
    if (0) { # No need to update callers of includes.
    foreach $cle1 (@$listetodestroy) {
        if (exists $$array{"$cle1"}) {
	    $new_point{$cle1} = 2 ;
	    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle1) ;
	    $new_include{$fic} = 2 if $fic ;
	    $new_inc_point{$cle1} = 1 ;
	}
    }
    }
}
#|#######################################################
sub destroy_dual_includes {
# Destruction niveau 1 des tableaux d'appel et mmorisation
# dans new_include et new_point
    my($listetodestroy,$array,$dual) = @_ ;
    if (0) { # No need to update callers of includes.
    foreach $cle1 (@$listetodestroy) {
	if (exists $$dual{"$cle1"}) {
	    foreach $cle2 (keys %{$$dual{"$cle1"}}) {
		if (exists ${$$dual{$cle1}}{$cle2}) {
		    $new_point{$cle2} = 1 unless exists $new_point{$cle2} ;
		    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle2) ;
		    if ($fic) {
			$new_include{$fic} = 1 unless exists $new_include{$fic} ;
			$new_inc_point{$cle2} = 1 ;
		    }
	        }
            }
        }
    }
    }
    foreach $cle1 (@$listetodestroy) {
	if (exists $$array{"$cle1"}) {
	    foreach $cle2 (keys %{$$array{"$cle1"}}) {
		if (exists ${$$dual{$cle2}}{$cle1}) {
		    $new_point{$cle2} = 1 unless exists $new_point{$cle2} ;
		    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle2) ;
		    if ($fic) {
			$new_include{$fic} = 1 unless exists $new_include{$fic} ;
			$new_inc_point{$cle2} = 1 ;
		    }
		    delete ${$$dual{$cle2}}{$cle1} ;
	        }
            }
        }
    }
    foreach $cle1 (@$listetodestroy) {
        if (exists $$array{"$cle1"}) {
            if (0) { # No need to update callers of includes.
	        $new_point{$cle1} = 2 ;
	        ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle1) ;
	        $new_include{$fic} = 2 if $fic ;
                $new_inc_point{$cle1} = 1 ;
	    }
	    delete $$array{"$cle1"} 
	}
    }
}
#|#######################################################
sub get_dual_inputs {
# Destruction niveau 1 des tableaux d'appel et mmorisation
# dans new_input et new_point
    my($listetodestroy,$array,$dual) = @_ ;
    if (0) { # No need to update callers of inputs.
    foreach $cle1 (@$listetodestroy) {
	if (exists $$dual{"$cle1"}) {
	    foreach $cle2 (keys %{$$dual{"$cle1"}}) {
		if (exists ${$$dual{$cle1}}{$cle2}) {
		    $new_point{$cle2} = 1 unless exists $new_point{$cle2} ;
		    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle2) ;
		    if ($fic) {
			$new_input{$fic} = 1 unless exists $new_input{$fic} ;
			$new_inp_point{$cle2} = 1 ;
		    }
	        }
            }
        }
    }
    }
    foreach $cle1 (@$listetodestroy) {
	if (exists $$array{"$cle1"}) {
	    foreach $cle2 (keys %{$$array{"$cle1"}}) {
		if (exists ${$$dual{$cle2}}{$cle1}) {
		    $new_point{$cle2} = 1 unless exists $new_point{$cle2} ;
		    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle2) ;
		    if ($fic) {
			$new_input{$fic} = 1 unless exists $new_input{$fic} ;
			$new_inp_point{$cle2} = 1 ;
		    }
	        }
            }
        }
    }
    if (0) { # No need to update callers of inputs.
    foreach $cle1 (@$listetodestroy) {
        if (exists $$array{"$cle1"}) {
	    $new_point{$cle1} = 2 ;
	    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle1) ;
	    $new_input{$fic} = 2 if $fic ;
	    $new_inp_point{$cle1} = 1 ;
	}
    }
    }
}
#|#######################################################
sub destroy_dual_inputs {
# Destruction niveau 1 des tableaux d'appel et mmorisation
# dans new_input et new_point
    my($listetodestroy,$array,$dual) = @_ ;
    if (0) { # No need to update callers of inputs.
    foreach $cle1 (@$listetodestroy) {
	if (exists $$dual{"$cle1"}) {
	    foreach $cle2 (keys %{$$dual{"$cle1"}}) {
		if (exists ${$$dual{$cle1}}{$cle2}) {
		    $new_point{$cle2} = 1 unless exists $new_point{$cle2} ;
		    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle2) ;
		    if ($fic) {
			$new_input{$fic} = 1 unless exists $new_input{$fic} ;
			$new_inp_point{$cle2} = 1 ;
		    }
	        }
            }
        }
    }
    }
    foreach $cle1 (@$listetodestroy) {
	if (exists $$array{"$cle1"}) {
	    foreach $cle2 (keys %{$$array{"$cle1"}}) {
		if (exists ${$$dual{$cle2}}{$cle1}) {
		    $new_point{$cle2} = 1 unless exists $new_point{$cle2} ;
		    ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle2) ;
		    if ($fic) {
			$new_input{$fic} = 1 unless exists $new_input{$fic} ;
			$new_inp_point{$cle2} = 1 ;
		    }
		    delete ${$$dual{$cle2}}{$cle1} ;
	        }
            }
        }
    }
    foreach $cle1 (@$listetodestroy) {
        if (exists $$array{"$cle1"}) {
            if (0) { # No need to update callers of inputs.
	        $new_point{$cle1} = 2 ;
	        ($a,$fic,$b) = &main::GetInfoRoutineCasei($cle1) ;
	        $new_input{$fic} = 2 if $fic ;
                $new_inp_point{$cle1} = 1 ;
	    }
	    delete $$array{"$cle1"} 
	}
    }
}
#|#######################################################
sub destroy_value_in_hash {
    local($listetodestroy,$array) = @_ ;
    foreach $cle2 (keys %{$array}) {
	foreach $cle1 (@$listetodestroy) {
	    if (exists ${$$array{$cle2}}{$cle1}) {
	        delete ${$$array{$cle2}}{$cle1} ;
            }
	}
    }
}
#|#######################################################
sub destroy_key_in_hash {
    local($listetodestroy,$array) = @_ ;
    foreach $cle (@$listetodestroy) {
	delete $$array{"$cle"} if exists $$array{"$cle"} ;
    }
}
#|#######################################################
sub destroy_key_in_hash_sayval {
    local($listetodestroy,$array) = @_ ;
    my(@sayval) = () ;
    foreach $cle (@$listetodestroy) {
	if (exists $$array{"$cle"}) {
	    if (defined($$array{"$cle"})){
		push(@sayval,keys %{$$array{"$cle"}}) ;
	    }
	    delete $$array{"$cle"} ;
	}
    }
    return(@sayval) ;
}
#|#######################################################
sub destroy_key_in_hash_sayvalue {
    local($listetodestroy,$array) = @_ ;
    my(@sayval) = () ;
    foreach $cle (@$listetodestroy) {
	if (exists $$array{"$cle"}) {
	    if (defined($$array{"$cle"})){
		push(@sayval,values %{$$array{"$cle"}}) ;
	    }
	    delete $$array{"$cle"} ;
	}
    }
    return(@sayval) ;
}
#|#######################################################
sub keep_key_in_hash_sayvalue {
    local($listetodestroy,$array) = @_ ;
    my(@sayval) = () ;
    foreach $cle (@$listetodestroy) {
	if (exists $$array{"$cle"}) {
	    if (defined($$array{"$cle"})){
		push(@sayval,values %{$$array{"$cle"}}) ;
	    }
	}
    }
    return(@sayval) ;
}
#|#######################################################
sub recursive_key_in_hash_sayvalue {
    local($listetodestroy,$array) = @_ ;
    my(@sayval) = (@$listetodestroy) ;
    my(@newsayval) = (@$listetodestroy) ;
    my(%ok) = () ;
    foreach $cle (@sayval) {
	$ok{$cle} = 1 ;
    }
    $c = 1 ;
    (@bissayval) = () ;
    while ($c) {
	$c = 0 ;
	foreach $cle1 (@newsayval) {
	    if (exists $$array{"$cle1"}) {
		foreach $cle2 (keys %{$$array{"$cle1"}}) {
		    if (${$$array{"$cle1"}}{$cle2}) {
		        push(@bissayval,$cle2) unless exists $ok{$cle2} ;
		        $ok{$cle2} = 1 ;
			$c = 1 ;
		    }
		}
	    }
	}
        push(@sayval,@bissayval) ;
        (@newsayval) = (@bissayval) ;
        (@bissayval) = () ;
    }
    (%ok) = () ;
    return(@sayval) ;
}
#|#######################################################
sub keep_key_in_hash_saykey {
    local($listetodestroy,$array) = @_ ;
    my(@sayval) = () ;
    my(%already_suppressed) = () ;
    foreach $cle (@$listetodestroy) {
	if (exists $$array{"$cle"}) {
	    while (($val,$a) = each %{$$array{"$cle"}}) {
		$already_suppressed{$val} = 1 ;
	    }
	}
    }
    while (($val,$a) = each %already_suppressed) {
	push(@sayval,$val) ;
    }
    return(@sayval) ;
}
#|#######################################################
sub destroy_value_input_in_hash {
    local($listetodestroy,$array) = @_ ;
    (%not_inputed) = () ;
    foreach $cle2 (keys %{$array}) {
	foreach $cle1 (@$listetodestroy) {
	    if (exists ${$$array{$cle2}}{$cle1}) {
	        $not_inputed{$cle2} = 1 ;
	        delete ${$$array{$cle2}}{$cle1} ;
            }
	}
    }
}
#|#######################################################
sub add_call_analysis_public_procedure {
# the hash table array is set to one on the values of
# File_Of_Rout of the elements of listetoadd.
    local($listetoadd,$array) = @_ ;
    foreach $cle (@$listetoadd) {
	if ($main::File_Of_Rout{$cle}) {
	    $$array{$main::File_Of_Rout{$cle}} = 1 ;
	}
    }
}
#|#######################################################
sub RemoveObsoleteInStar {
    local(*INFO) = "main::INFO_Html" ;
    my(@files) = () ;
    print INFO "\t3) Start of cleaning includes.\n" if $debug;
    if (%{main::f90included}) {
	foreach $cle1 (keys %{main::f90included}) {
	    (%a) = (%{$main::f90included{"$cle1"}}) ;
	    unless (%a) {
		($b,$file,$c) = &main::GetInfoRoutineCasei($cle1) ;
		push(@files,$file) ;
		delete ${main::f90included}{$cle1} ;
	        delete $new_inc_point{$cle1} if exists $new_inc_point{$cle1} ;
	    }
	}
    }
    print INFO "\t3) Start of cleaning inputs.\n" if $debug;
    if (%{main::latexinputed}) {
	foreach $cle1 (keys %{main::latexinputed}) {
	    (%a) = (%{$main::latexinputed{"$cle1"}}) ;
	    unless (%a) {
		($b,$file,$c) = &main::GetInfoRoutineCasei($cle1) ;
		push(@files,$file) ;
		delete ${main::latexinputed}{$cle1} ;
	        delete $new_inp_point{$cle1} if exists $new_inp_point{$cle1} ;
	    }
	}
    }
    print INFO "\t3) Cleaning labels.\n" if $debug;
    &SuppressLabel(\@files) ;
    print INFO "\t3) End of cleaning.\n" if $debug;
}
#|#######################################################
sub AddSourcesToRehtml {
    local(*INFO) = "main::INFO_Html" ;
    print INFO "\t3) Start of analysis.\n" if $debug;

    (@level3files) = (keys %new_file) ;
    print INFO "\t3) Sources to Rehtml are level3files=\n" if ($debug) ;
    &PrintDebug(1,\@level3files) if $debug;
    print INFO "\t3) Automatic type determination for sources.\n" if ($debug) ;
    &main::Determine_Types(@level3files) ;

    (@restart3include) = (keys %new_inc_point) ;
    print INFO "\t3) Includes to Rehtml are restart3include=\n" if ($debug) ;
    &PrintDebug(1,\@restart3include) if $debug;
    print INFO "\t3) Automatic type determination for includes.\n" if ($debug) ;
    &GetListeh(1,@restart3include) ;

    (@restart3input) = (keys %new_inp_point) ;
    print INFO "\t3) Inputs to Rehtml are restart3input=\n" if ($debug) ;
    &PrintDebug(1,\@restart3input) if $debug;
    print INFO "\t3) Automatic type determination for inputs.\n" if ($debug) ;
    &GetListet(1,@restart3input) ;

    print INFO "\t3) End of analysis.\n" if $debug;
}
#|#######################################################
sub PrintDebug {
    my($lev,$array) = @_ ;
    my($tab) = "" ;
    for ($i=0; $i< $lev; $i++ ) {
	$tab .= "\t" ;
    }
    foreach $a (@{$array}) {
	print INFO "$tab   $a\n" ;
    }
}
#|#######################################################
sub GetListet {
    my($level,@files) = @_ ;
    foreach $file (@files) {
	push(@main::restarttex,$file) ;
    }
}
#|#######################################################
sub OLDdestroyupentries {
# Now, since this is called at the higher level possible,
# we shoul not destroy higher level procedures.
# Aims at destroying wrong entries in Appellees Appelants 
# and realcalls realcalled.
    foreach $point (@destroyfiles,@addfiles) {
	$destpoint{$point} = 1 ;
    }
    (@newdestroydefs) =() ;
    foreach $point (@destroydefs) {
	(@newdest) = (keys %{$main::realcalled{"$point"}}) ;
	foreach $newpoint (@newdest) {
	    local($localProc,$localFile,$localNum) = main::GetInfoRoutine($newpoint) ;
	    unless ($destpoint{$point}) {
		push(@addfiles,$localFile) ;
		push(@newdestroydefs,@{$main::lfichiers{$localFile}});
		$destpoint{$point} = 1 ;
		print INFO "# New File Points is $localFile\n" if $debug;
# newdestroydefs permet de tuer les cls de realcalls et de Appellees avec les valeurs
# de Appelants et de realcalled.
	    }
	}
    }
    foreach $file (@addfiles) {
	$point = "$file:$file:0";
	unless ($destpoint{$point}) {
	    push(@newdestroydefs,$point);
	}
    }
    (@vnewdestroydefs) = () ;
    foreach $point (@newdestroydefs) {
	(@newdest) = (values %{$main::realcalls{"$point"}}) ;
	push(@vnewdestroydefs,@newdest);
    }
    print INFO "#\tArray realcalled and Appelants cleaned from '@vnewdestroydefs'.\n" if ($debug) ;
    &destroy_key_in_hash(\@newdestroydefs,\%{main::realcalls}) ;
    &destroy_key_in_hash(\@newdestroydefs,\%{main::Appellees}) ;
    &destroy_value_in_hash(\@newdestroydefs,\%{main::realcalled}) ;
    &destroy_value_in_hash(\@newdestroydefs,\%{main::Appelants}) ;
    &destroy_key_in_hash(\@newdestroydefs,\%{main::f90includes}) ;
    &destroy_value_in_hash(\@newdestroydefs,\%{main::f90included}) ;
    &destroy_key_in_hash(\@newdestroydefs,\%{main::latexinputs}) ;
    &destroy_value_in_hash(\@newdestroydefs,\%{main::latexinputed}) ;
    &destroy_key_in_hash(\@newdestroydefs,\%{main::available}) ;
    &destroy_key_in_hash(\@newdestroydefs,\%{main::realuses}) ;
    &destroy_value_in_hash(\@newdestroydefs,\%{main::realused}) ;
    print INFO "#\tArray realcalled and Appelants cleaned from '@newdestroydefs'.\n" if ($debug) ;
}
#|#######################################################
sub OldGetListe3h {
    &GetListeh(1,@restart2inc) ;
}
#|#######################################################
sub save_hash_in_file {
    local ($array_name, %array) = @_;
    local ($cle, $valeur, $ligne) = ("","","");
    if (%array) {
	$ligne .= "#Array $array_name is defined below\n";
	while (($cle,$valeur) = each %array) {
	    $ligne .= "  \$".$array_name."{\"$cle\"} = \"$valeur\" ;\n";
	}
	$ligne .= "#Array $array_name was defined above\n";
    } else {
	$ligne .= "#Array $array_name is empty\n";
    }
    return ($ligne);
}
#|#######################################################
sub save_array_in_file {
    local ($array_name, @liste) = @_;
    local ($val, $ligne) = ("","");
    if (@liste) {
	$ligne .= "#List $array_name is defined below\n";
	$val = join '", "',@liste ;
	$ligne .= ' @'.$array_name." = (\"$val\") ;\n";
#	$ligne .= "  @".$array_name." =  (";
#	foreach $cle (@liste) {
#	    $ligne .= "\"$cle\", ";
#	}
#	chop($ligne); chop($ligne);
#	$ligne .= ");\n";
	$ligne .= "#List $array_name was defined above\n";
    } else {
	$ligne .= "#List $array_name is empty\n";
    }
    return ($ligne);
}
#|#######################################################
sub save_hash_array_in_file {
    local ($array_name, %array) = @_;
    local ($cle1, $val, $ligne) = ("","","");
    if (%array) {
	$ligne .= "#Array $array_name is defined below\n";
	local (%valeur) = ();
	foreach $cle1 (keys %array) {
	    $val = join '", "',@{$array{$cle1}} ;
	    $ligne .= ' @{$'.$array_name."{\"$cle1\"}} = (\"$val\") ;\n";
        }
	$ligne .= "#Array $array_name was defined above\n";
    } else {
	$ligne .= "#Array $array_name is empty\n";
    }
    return ($ligne);
}
#|#######################################################
sub save_hash_hash_in_file {
    local ($array_name, %array) = @_;
    local ($cle1, $cle2, $val, $ligne) = ("","","","");
    if (%array) {
	$ligne .= "#Array $array_name is defined below\n";
	local (%valeur) = ();
	foreach $cle1 (keys %array) {
#	    $ligne .= "  \$".$array_name."{\"$cle1\"} = () ;\n";
	    foreach $cle2 (keys %{$array{$cle1}}) {
		$val = ${$array{$cle1}}{$cle2} ;
	        $ligne .= '  ${$'.$array_name."{\"$cle1\"}}{\"$cle2\"} = \"".$val."\" ;\n";
	    }
        }
	$ligne .= "#Array $array_name was defined above\n";
    } else {
	$ligne .= "#Array $array_name is empty\n";
    }
    return ($ligne);
}
#|#######################################################
sub save_hash_hash_array_in_file {
    local ($array_name, %array) = @_;
    local ($cle1, $cle2, $ligne) = ("","","","");
    if (%array) {
	$ligne .= "#Array $array_name is defined below\n";
	foreach $cle1 (keys %array) {
	    foreach $cle2 (keys %{$array{$cle1}}) {
		local(@val) = join '", "', @{${$array{$cle1}}{$cle2}} ;
	        $ligne .= "  \@{\${\$".$array_name."{\"$cle1\"}}{\"$cle2\"}} = (\"@val\");\n";
	    }
        }
	$ligne .= "#Array $array_name was defined above\n";
    } else {
	$ligne .= "#Array $array_name is empty\n";
    }
    return ($ligne);
}
#|#######################################################
sub TagsInfo {
    my($INFO)=@_ ;
    *INFO = "main::$INFO" ;
    print INFO "# Stage 1:\n#Information related to the definition points\n";
    print INFO "\$currentversion = $main::currentversion ;\n" ;
    if ($main::currenttime) {
	print INFO "#\$currenttime = ". $main::currenttime . ";\n" ;
    }
    print INFO "\$currenttime = ". time . ";\n" ;
    print INFO save_hash_in_file ("L_Declar", %main::L_Declar);
    print INFO save_hash_in_file ("R_Declar", %main::R_Declar);
    print INFO save_hash_in_file ("File_Of_Rout", %main::File_Of_Rout);
    print INFO save_hash_in_file ("R_Include", %main::R_Include);
    print INFO save_hash_in_file ("father", %main::father);
    print INFO save_hash_hash_in_file ("sons", %main::sons);
    print INFO save_hash_in_file ("programmes", %main::programmes);
    print INFO save_hash_in_file ("functions", %main::functions);
    print INFO save_hash_in_file ("routines", %main::routines);
    print INFO save_hash_in_file ("module", %main::module);
    print INFO save_hash_array_in_file ("lfichiers", %main::lfichiers);
    print INFO save_hash_hash_array_in_file ("f90includes", %main::f90includes);
    print INFO save_hash_hash_array_in_file ("f90included", %main::f90included);
    print INFO save_hash_hash_array_in_file ("latexinputs", %main::latexinputs);
    print INFO save_hash_hash_array_in_file ("latexinputed", %main::latexinputed);
    print INFO save_hash_in_file ("Include_Unique", %main::Include_Unique);
    print INFO save_hash_in_file ("Input_Unique", %main::Input_Unique);
    print INFO save_hash_in_file ("Input_Alias", %main::Input_Alias);
    print INFO save_hash_in_file ("Include_Alias", %main::Include_Alias);
    print INFO "# End of Stage 1\n";
}
#|#######################################################
sub CallsInfo {
    my($INFO)=@_ ;
    *INFO = "main::$INFO" ;
    print INFO "# Stage 2:\n#Information related to the calling points\n";
    print INFO save_hash_in_file ("label", %main::label);
    print INFO save_hash_array_in_file ("revlab", %main::revlab);
    print INFO save_hash_hash_in_file ("Appellees", %main::Appellees);
    print INFO save_hash_hash_in_file ("Appelants", %main::Appelants);
    print INFO save_hash_hash_in_file ("realcalls", %main::realcalls);
    print INFO save_hash_hash_in_file ("realcalled", %main::realcalled);
    print INFO save_hash_hash_in_file ("rename", %main::rename);
    print INFO save_hash_hash_in_file ("available", %main::available);
    print INFO save_hash_hash_array_in_file ("effectcalled", %main::effectcalled);
    print INFO save_hash_hash_array_in_file ("realuses", %main::realuses);
    print INFO save_hash_hash_array_in_file ("realused", %main::realused);
    print INFO "# End of Stage 2\n";
}
#|#######################################################
#|#######################################################
1;


