package information;
sub main::information {
    $helpfile="/tmp/getin.help";
    open(HELP,">$helpfile");
    print HELP <<'INFORMATION';
Ceci est un programme 'perl':
<li> Objet:
    Recherche, sans considration de casse, de variables
    (mots ou expressions) passes en argument.
    La recherche est intelligente, rcursive et multiple
    dans les programmes C, fortran, html, latex ....

<li> Liste des options:
<a href="#A">A</a>,  
<a href="#a">a</a>.
<a href="#B">B</a>,  
<a href="#b">b</a>.
<a href="#d">d</a>,  
<a href="#D">D</a>,  
<a href="#e">e</a>,  
<a href="#f">f</a>,  
<a href="#F">F</a>,  
<a href="#H">H</a>,  
<a href="#I">I</a>,  
<a href="#l">l</a>,  
<a href="#L">L</a>,  
<a href="#o">o</a>,  
<a href="#P">P</a>,  
<a href="#r">r</a>,  
<a href="#R">r</a>,  
<a href="#S">S</a>,  
<a href="#t">t</a>,  
<a href="#v">v</a>,  
<a href="#X">X</a>,  
<a href="#Y">Y</a>,  
<ul>
<li>  -<a name="A">A</a>: L'option -A Numro  permet d'afficher les lignes
      qui matchent la recherche et les 'Numro' lignes qui suivent les lignes de match.
      Ceci permet d'viter l'affectation de la variable d'environnement 'L_Aft'.
<li>  -<a name="a">a</a>: L'option -a permet d'afficher les lignes
      d'appel ou de dclaration
      selon l'option S ou P demande et de lister, par variable les
      dfinitions (S) ou appels (P) de la variable.
      Cette option n'a de sens que conjugue aux options P ou S.
<li>  -<a name="B">B</a>: L'option -B Numro  permet d'afficher les lignes
      qui matchent la recherche et les 'Numro' lignes qui prcdent les lignes de match.
      Ceci permet d'viter l'affectation de la variable d'environnement 'L_Bef'.
<li>  -<a name="b">b</a>: L'option -b conjugue  l'option -t permet
      de faire une recherche
      sur tous les fichiers des rpertoires de la variable <TT>GETIN_PATH</TT>.
      L'option -t seulement ne permet d'tendre la recherche aux rpertoires
      de la variable <TT>GETIN_PATH</TT> que pour la recherche des includes.
      L'option -b conjugue  l'option -R permet de faire une recherche
      rcursive  partir du rpertoire local et des ventuels rpertoire
      si option -t ou option -I noms_des_rpertoires_spars_par:
<li>  -<a name="d">d</a>: L'option -d permet d'effectuer une recherche
      de dclaration dans le fortran et le C en liminant les commentaires.
<li>  -<a name="D">D</a>: L'option -D permet d'afficher les blocs "subroutine"
      ou les blocs "call" ou "function" qui contiennent la variable en question.
      L'affichage donne automatiquement toutes les lignes du bloc.
<li>  -<a name="e">e</a>: L'option -e permet de rechercher les affectations de
      variables dans le fortran et le C en liminant les commentaires.
<li>  -<a name="I">I</a>: L'option -I Rpertoires_Path permet de mettre sur le mme plan
      le rpertoire local
      et les rpertoires dont les noms suivent l'option I, spars par ':'
      pour la recherche des includes.
      Ceci permet une recherche sur un rpertoire de dveloppement
      local ainsi que sur plusieurs rpertoires d'industrialisation.
<li>  -<a name="f">f</a>: L'option -f permet d'effectuer une recherche
      sur les lignes de programme dans le fortran et le C.
<li>  -<a name="F">F</a>: L'option -F permet d'effectuer une recherche
      sur les lignes de commentaire dans le fortran et le C.
<li>  -<a name="H">H</a>: L'option -H permet de savoir si une variable est utilise
      pour l'affectation d'une autre variable. Option valide sur le fortran
      seulement.
<li>  -<a name="l">l</a>: L'option -l permet d'effectuer une recherche
      sur les expressions
      protges (i.e \_ remplac par \\_ pour les commentaires en LaTeX) en
      plus de l'expression non protge.
<li>  -<a name="L">L</a>: L'option -L permet d'effectuer une recherche
      sur les expressions
      protges (i.e \_ remplac par \\_ pour les commentaires en LaTeX)
       la place de l'expression non protge.
<li>  -<a name="o">o</a>: L'option -o permet d'effectuer une
      recherche sur les occurrences de chane.
<li>  -<a name="P">P</a>: L'option -P permet de rechercher les
      passages de paramtres
      marqus par le mot-clef 'call' o le paramtre du call
      (pass en argument  getin) diffre du nom de la variable
      de dfinition dans la subroutine: exemple
      <PRE>
      a.f: L1=program a L2=call b(xa,ya,za,wa) L3=end
      b.f: L1=subroutine b(xb,yb,zb,wb) L2=end
          getin -P wa a.f b.f: b(wa,a.f,2,4)[b.f,1]=wb
      </PRE>
<li>  -<a name="r">r</a>: L'option -r permet d'effectuer une recherche
      rcursive  partir
      d'un fichier subroutine fortran sur tous ses calls,  condition
      que les appeles portent le mme nom.
<li>  -<a name="R">R</a>: L'option -R permet d'effectuer une recherche
      rcursive  partir du rpertoire local. Cette option est  conjuguer
       l'option -b si cette recherche rcursive doit porter sur les arguments.
      Remarque: avec cette option il est impossible d'avoir les \*.f rcursifs
<li>  -<a name="S">S</a>: L'option -S permet de rechercher les passages de paramtres
      marqus par le mot-clef 'subroutine' o la variable de
      la dfinition de la subroutine (variable passe en argument 
      getin) diffre du nom du paramtre d'appel ailleurs lors
      d'un "call". C'est la "rciproque" de l'option -P.
      <BR>Exemple
      <PRE>
      a.f: L1=program a L2=call b(xa,ya,za,wa) L3=end
      b.f: L1=subroutine b(xb,yb,zb,wb) L2=end
          getin -S wb a.f b.f: b(wb,b.f,1,4)[a.f,2]=wa
      </PRE>
<li>  -<a name="t">t</a>: L'option -t permet de mettre sur le mme plan
      le rpertoire local
      et les rpertoires dont les noms sont dans la variable
      d'environnement <TT>GETIN_PATH</TT> <b>pour la recherche des includes</b>.
      Ceci permet une recherche sur un rpertoire de dveloppement
      local ainsi que sur plusieurs rpertoires d'industrialisation.
<li>  -<a name="v">v</a>: L'option -v pour "verbose" permet de suivre les
      messages de fonctionnement de getin. On attend un entier donnant la
      quantit de commentaires  effectuer.
<li>  -<a name="X">X</a>: L'option -X FICHIER demande  ce programme
      de constituer un FICHIER
      qui contient tous les fichiers appels par les arguments analyss
      comme tant des fichiers. Par exemple, permet de constituer,
       partir
      d'un fichier fortran pass en argument, un unique fichier FICHIER
      contenant le fortran et les includes rcursifs.
<li>  -<a name="Y">Y</a>: L'option -Y FICHIER demande  getin
      de constituer un FICHIER.html
      qui liste les fichiers pour lesquels la recherche effectue est positive.
</ul>

<li> Dpendances:
<ul>
<li>  + Si on demande une recherche dans des fichiers '.h', on recherche
    dans les fichiers .h et .f et .c passs en argument uniquement
    (quivalent  un 'grep -iw amlior, voir la suite).
<li>  + Si l'on ne passe pas d'argument, recherche automatique dans tous
    les fichiers fortran, c et includes (et f90 et cc).
<li>  + Sinon on recherche dans les fichiers fortran .f et .c  et leurs
    dpendances, c'est--dire les fichiers include inclus, rcursivement.
<li>  + Si option -r on recherche dans les fichiers *.f o * est un nom
    trouv aprs l'instruction call. La recherche est rcursive 
     partir des fichiers dj connus.
</ul>

<li> Affichage du rsultat:
<ul>
<li>  * On affiche ensuite les numros de ligne concerns ainsi que
    les L_Bef=$L_Bef lignes prcdentes et les L_Aft=$L_Aft lignes
    suivantes (variables d'environnement modifiables si l'on ne veut
    pas du dfaut).
<li>  * Si option -P on n'affiche que les diffrences entre les call *(a)
    et les subroutine *(b) -affiche puisque a est diffrent de b, si
    a=b, n'affiche rien).
</ul>

<li> Priorits:
<ul>
<li>1) recherche d'expression (si mtacaracteres en arguments, ou option -o).
Sinon:
<li>2.a) Recherche d'affectation de variable si option -e,
<li>2.b) recherche de dclaration de paramtres ou affectation
     par 'quivalence', 'data' si option -d,
<li>2.c) recherche de passages de paramtres si option -p,
<li>2.d) rech. des pass. de para. diffrents de ceux de la
     dclaration, opt. -P.
Sinon:
<li>3) Recherche de mots.
</ul>
<li> Bugs: <A href="mailto:cessenat@free.fr">Olivier Cessenat</a>
</ul>
<P> N'oubliez-pas que getin peut se lancer par interface graphique avec
<A HREF="tkWorld.tcl">"tkWorld"</A> et dans emacs
en mettant la ligne <TT>(require 'getin)</TT> dans son
<TT>~/.emacs</TT>, puis  l'aide du menu Tools/Getin...
INFORMATION
    close(HELP);
    print `cat $helpfile` ;
    print "Veuillez-consulter le fichier
$ENV{'GETIN_DIR'}/doc/getin.html
avec
netscape -remote 'openURL(file:$ENV{'GETIN_DIR'}/doc/getin.html)'
" ;
    print "Je cre une image de l'aide sous $helpfile\n";
}
1;
